#ifndef ATL_RESTRICT
#if defined(__STDC_VERSION__) && (__STDC_VERSION__/100 >= 1999)
   #define ATL_RESTRICT restrict
#else
   #define ATL_RESTRICT
#endif
#endif
#include "atlas_prefetch.h"

void ATL_cJIK84x0x84TN84x84x0_a1_b0
   (const int M, const int N, const int K, const float alpha, const float * ATL_RESTRICT A, const int lda, const float * ATL_RESTRICT B, const int ldb, const float beta, float * ATL_RESTRICT C, const int ldc)
/*
 * matmul with TA=T, TB=N, MB=84, NB=0, KB=84, 
 * lda=84, ldb=84, ldc=0, mu=4, nu=1, ku=84, pf=1
 * Generated by ATLAS/tune/blas/gemm/emit_mm.c (3.10.3)
 */
{
   #define Nb N
   const float *stM = A + 7056;
   const float *stN = B + (84*(Nb));
   const float *pfA = stM;
   const int incPFA0 = (((int)(stM - A))*4*1)/(84*N*sizeof(float));
   const int incPFA = (1 > incPFA0) ? 1 : incPFA0;
   #define incAk 84
   const int incAm = 252, incAn = -7056;
   #define incBk 84
   const int incBm = -84, incBn = 84;
   const int incAk0 = ((incAk) / 84), incBk0 = ((incBk) / 84);
   #define incCm 8
   const int incCn = (((ldc) << 1)) - 168;
   float *pC0=C;
   const float *pA0=A;
   const float *pB0=B;
   register int k;
   register float rA0, rA1, rA2, rA3;
   register float rB0;
   register float m0, m1, m2, m3;
   register float rC0_0, rC1_0, rC2_0, rC3_0;
   do /* N-loop */
   {
      do /* M-loop */
      {
         ATL_pfl1R(pfA);
         pfA += incPFA;
         ATL_pfl1W(pC0);
/*
 *       Start pipeline
 */
         rA0 = *pA0;
         rB0 = *pB0;
         m0 = rA0 * rB0;
         rA1 = pA0[84];
         rA2 = pA0[168];
         m1 = rA1 * rB0;
         rA3 = pA0[252];
         m2 = rA2 * rB0;
         m3 = rA3 * rB0;
         rA0 = pA0[1];
         rB0 = pB0[1];
         rA1 = pA0[85];
         rA2 = pA0[169];

/*
 *       Completely unrolled K-loop
 */
         rC0_0 = m0;
         m0 = rA0 * rB0;
         rA3 = pA0[253];
         rC1_0 = m1;
         m1 = rA1 * rB0;
         rC2_0 = m2;
         m2 = rA2 * rB0;
         rC3_0 = m3;
         m3 = rA3 * rB0;
         rA0 = pA0[2];
         rB0 = pB0[2];
         rA1 = pA0[86];
         rA2 = pA0[170];
         rC0_0 += m0;
         m0 = rA0 * rB0;
         rA3 = pA0[254];
         rC1_0 += m1;
         m1 = rA1 * rB0;
         rC2_0 += m2;
         m2 = rA2 * rB0;
         rC3_0 += m3;
         m3 = rA3 * rB0;
         rA0 = pA0[3];
         rB0 = pB0[3];
         rA1 = pA0[87];
         rA2 = pA0[171];
         rC0_0 += m0;
         m0 = rA0 * rB0;
         rA3 = pA0[255];
         rC1_0 += m1;
         m1 = rA1 * rB0;
         rC2_0 += m2;
         m2 = rA2 * rB0;
         rC3_0 += m3;
         m3 = rA3 * rB0;
         rA0 = pA0[4];
         rB0 = pB0[4];
         rA1 = pA0[88];
         rA2 = pA0[172];
         rC0_0 += m0;
         m0 = rA0 * rB0;
         rA3 = pA0[256];
         rC1_0 += m1;
         m1 = rA1 * rB0;
         rC2_0 += m2;
         m2 = rA2 * rB0;
         rC3_0 += m3;
         m3 = rA3 * rB0;
         rA0 = pA0[5];
         rB0 = pB0[5];
         rA1 = pA0[89];
         rA2 = pA0[173];
         rC0_0 += m0;
         m0 = rA0 * rB0;
         rA3 = pA0[257];
         rC1_0 += m1;
         m1 = rA1 * rB0;
         rC2_0 += m2;
         m2 = rA2 * rB0;
         rC3_0 += m3;
         m3 = rA3 * rB0;
         rA0 = pA0[6];
         rB0 = pB0[6];
         rA1 = pA0[90];
         rA2 = pA0[174];
         rC0_0 += m0;
         m0 = rA0 * rB0;
         rA3 = pA0[258];
         rC1_0 += m1;
         m1 = rA1 * rB0;
         rC2_0 += m2;
         m2 = rA2 * rB0;
         rC3_0 += m3;
         m3 = rA3 * rB0;
         rA0 = pA0[7];
         rB0 = pB0[7];
         rA1 = pA0[91];
         rA2 = pA0[175];
         rC0_0 += m0;
         m0 = rA0 * rB0;
         rA3 = pA0[259];
         rC1_0 += m1;
         m1 = rA1 * rB0;
         rC2_0 += m2;
         m2 = rA2 * rB0;
         rC3_0 += m3;
         m3 = rA3 * rB0;
         rA0 = pA0[8];
         rB0 = pB0[8];
         rA1 = pA0[92];
         rA2 = pA0[176];
         rC0_0 += m0;
         m0 = rA0 * rB0;
         rA3 = pA0[260];
         rC1_0 += m1;
         m1 = rA1 * rB0;
         rC2_0 += m2;
         m2 = rA2 * rB0;
         rC3_0 += m3;
         m3 = rA3 * rB0;
         rA0 = pA0[9];
         rB0 = pB0[9];
         rA1 = pA0[93];
         rA2 = pA0[177];
         rC0_0 += m0;
         m0 = rA0 * rB0;
         rA3 = pA0[261];
         rC1_0 += m1;
         m1 = rA1 * rB0;
         rC2_0 += m2;
         m2 = rA2 * rB0;
         rC3_0 += m3;
         m3 = rA3 * rB0;
         rA0 = pA0[10];
         rB0 = pB0[10];
         rA1 = pA0[94];
         rA2 = pA0[178];
         rC0_0 += m0;
         m0 = rA0 * rB0;
         rA3 = pA0[262];
         rC1_0 += m1;
         m1 = rA1 * rB0;
         rC2_0 += m2;
         m2 = rA2 * rB0;
         rC3_0 += m3;
         m3 = rA3 * rB0;
         rA0 = pA0[11];
         rB0 = pB0[11];
         rA1 = pA0[95];
         rA2 = pA0[179];
         rC0_0 += m0;
         m0 = rA0 * rB0;
         rA3 = pA0[263];
         rC1_0 += m1;
         m1 = rA1 * rB0;
         rC2_0 += m2;
         m2 = rA2 * rB0;
         rC3_0 += m3;
         m3 = rA3 * rB0;
         rA0 = pA0[12];
         rB0 = pB0[12];
         rA1 = pA0[96];
         rA2 = pA0[180];
         rC0_0 += m0;
         m0 = rA0 * rB0;
         rA3 = pA0[264];
         rC1_0 += m1;
         m1 = rA1 * rB0;
         rC2_0 += m2;
         m2 = rA2 * rB0;
         rC3_0 += m3;
         m3 = rA3 * rB0;
         rA0 = pA0[13];
         rB0 = pB0[13];
         rA1 = pA0[97];
         rA2 = pA0[181];
         rC0_0 += m0;
         m0 = rA0 * rB0;
         rA3 = pA0[265];
         rC1_0 += m1;
         m1 = rA1 * rB0;
         rC2_0 += m2;
         m2 = rA2 * rB0;
         rC3_0 += m3;
         m3 = rA3 * rB0;
         rA0 = pA0[14];
         rB0 = pB0[14];
         rA1 = pA0[98];
         rA2 = pA0[182];
         rC0_0 += m0;
         m0 = rA0 * rB0;
         rA3 = pA0[266];
         rC1_0 += m1;
         m1 = rA1 * rB0;
         rC2_0 += m2;
         m2 = rA2 * rB0;
         rC3_0 += m3;
         m3 = rA3 * rB0;
         rA0 = pA0[15];
         rB0 = pB0[15];
         rA1 = pA0[99];
         rA2 = pA0[183];
         rC0_0 += m0;
         m0 = rA0 * rB0;
         rA3 = pA0[267];
         rC1_0 += m1;
         m1 = rA1 * rB0;
         rC2_0 += m2;
         m2 = rA2 * rB0;
         rC3_0 += m3;
         m3 = rA3 * rB0;
         rA0 = pA0[16];
         rB0 = pB0[16];
         rA1 = pA0[100];
         rA2 = pA0[184];
         rC0_0 += m0;
         m0 = rA0 * rB0;
         rA3 = pA0[268];
         rC1_0 += m1;
         m1 = rA1 * rB0;
         rC2_0 += m2;
         m2 = rA2 * rB0;
         rC3_0 += m3;
         m3 = rA3 * rB0;
         rA0 = pA0[17];
         rB0 = pB0[17];
         rA1 = pA0[101];
         rA2 = pA0[185];
         rC0_0 += m0;
         m0 = rA0 * rB0;
         rA3 = pA0[269];
         rC1_0 += m1;
         m1 = rA1 * rB0;
         rC2_0 += m2;
         m2 = rA2 * rB0;
         rC3_0 += m3;
         m3 = rA3 * rB0;
         rA0 = pA0[18];
         rB0 = pB0[18];
         rA1 = pA0[102];
         rA2 = pA0[186];
         rC0_0 += m0;
         m0 = rA0 * rB0;
         rA3 = pA0[270];
         rC1_0 += m1;
         m1 = rA1 * rB0;
         rC2_0 += m2;
         m2 = rA2 * rB0;
         rC3_0 += m3;
         m3 = rA3 * rB0;
         rA0 = pA0[19];
         rB0 = pB0[19];
         rA1 = pA0[103];
         rA2 = pA0[187];
         rC0_0 += m0;
         m0 = rA0 * rB0;
         rA3 = pA0[271];
         rC1_0 += m1;
         m1 = rA1 * rB0;
         rC2_0 += m2;
         m2 = rA2 * rB0;
         rC3_0 += m3;
         m3 = rA3 * rB0;
         rA0 = pA0[20];
         rB0 = pB0[20];
         rA1 = pA0[104];
         rA2 = pA0[188];
         rC0_0 += m0;
         m0 = rA0 * rB0;
         rA3 = pA0[272];
         rC1_0 += m1;
         m1 = rA1 * rB0;
         rC2_0 += m2;
         m2 = rA2 * rB0;
         rC3_0 += m3;
         m3 = rA3 * rB0;
         rA0 = pA0[21];
         rB0 = pB0[21];
         rA1 = pA0[105];
         rA2 = pA0[189];
         rC0_0 += m0;
         m0 = rA0 * rB0;
         rA3 = pA0[273];
         rC1_0 += m1;
         m1 = rA1 * rB0;
         rC2_0 += m2;
         m2 = rA2 * rB0;
         rC3_0 += m3;
         m3 = rA3 * rB0;
         rA0 = pA0[22];
         rB0 = pB0[22];
         rA1 = pA0[106];
         rA2 = pA0[190];
         rC0_0 += m0;
         m0 = rA0 * rB0;
         rA3 = pA0[274];
         rC1_0 += m1;
         m1 = rA1 * rB0;
         rC2_0 += m2;
         m2 = rA2 * rB0;
         rC3_0 += m3;
         m3 = rA3 * rB0;
         rA0 = pA0[23];
         rB0 = pB0[23];
         rA1 = pA0[107];
         rA2 = pA0[191];
         rC0_0 += m0;
         m0 = rA0 * rB0;
         rA3 = pA0[275];
         rC1_0 += m1;
         m1 = rA1 * rB0;
         rC2_0 += m2;
         m2 = rA2 * rB0;
         rC3_0 += m3;
         m3 = rA3 * rB0;
         rA0 = pA0[24];
         rB0 = pB0[24];
         rA1 = pA0[108];
         rA2 = pA0[192];
         rC0_0 += m0;
         m0 = rA0 * rB0;
         rA3 = pA0[276];
         rC1_0 += m1;
         m1 = rA1 * rB0;
         rC2_0 += m2;
         m2 = rA2 * rB0;
         rC3_0 += m3;
         m3 = rA3 * rB0;
         rA0 = pA0[25];
         rB0 = pB0[25];
         rA1 = pA0[109];
         rA2 = pA0[193];
         rC0_0 += m0;
         m0 = rA0 * rB0;
         rA3 = pA0[277];
         rC1_0 += m1;
         m1 = rA1 * rB0;
         rC2_0 += m2;
         m2 = rA2 * rB0;
         rC3_0 += m3;
         m3 = rA3 * rB0;
         rA0 = pA0[26];
         rB0 = pB0[26];
         rA1 = pA0[110];
         rA2 = pA0[194];
         rC0_0 += m0;
         m0 = rA0 * rB0;
         rA3 = pA0[278];
         rC1_0 += m1;
         m1 = rA1 * rB0;
         rC2_0 += m2;
         m2 = rA2 * rB0;
         rC3_0 += m3;
         m3 = rA3 * rB0;
         rA0 = pA0[27];
         rB0 = pB0[27];
         rA1 = pA0[111];
         rA2 = pA0[195];
         rC0_0 += m0;
         m0 = rA0 * rB0;
         rA3 = pA0[279];
         rC1_0 += m1;
         m1 = rA1 * rB0;
         rC2_0 += m2;
         m2 = rA2 * rB0;
         rC3_0 += m3;
         m3 = rA3 * rB0;
         rA0 = pA0[28];
         rB0 = pB0[28];
         rA1 = pA0[112];
         rA2 = pA0[196];
         rC0_0 += m0;
         m0 = rA0 * rB0;
         rA3 = pA0[280];
         rC1_0 += m1;
         m1 = rA1 * rB0;
         rC2_0 += m2;
         m2 = rA2 * rB0;
         rC3_0 += m3;
         m3 = rA3 * rB0;
         rA0 = pA0[29];
         rB0 = pB0[29];
         rA1 = pA0[113];
         rA2 = pA0[197];
         rC0_0 += m0;
         m0 = rA0 * rB0;
         rA3 = pA0[281];
         rC1_0 += m1;
         m1 = rA1 * rB0;
         rC2_0 += m2;
         m2 = rA2 * rB0;
         rC3_0 += m3;
         m3 = rA3 * rB0;
         rA0 = pA0[30];
         rB0 = pB0[30];
         rA1 = pA0[114];
         rA2 = pA0[198];
         rC0_0 += m0;
         m0 = rA0 * rB0;
         rA3 = pA0[282];
         rC1_0 += m1;
         m1 = rA1 * rB0;
         rC2_0 += m2;
         m2 = rA2 * rB0;
         rC3_0 += m3;
         m3 = rA3 * rB0;
         rA0 = pA0[31];
         rB0 = pB0[31];
         rA1 = pA0[115];
         rA2 = pA0[199];
         rC0_0 += m0;
         m0 = rA0 * rB0;
         rA3 = pA0[283];
         rC1_0 += m1;
         m1 = rA1 * rB0;
         rC2_0 += m2;
         m2 = rA2 * rB0;
         rC3_0 += m3;
         m3 = rA3 * rB0;
         rA0 = pA0[32];
         rB0 = pB0[32];
         rA1 = pA0[116];
         rA2 = pA0[200];
         rC0_0 += m0;
         m0 = rA0 * rB0;
         rA3 = pA0[284];
         rC1_0 += m1;
         m1 = rA1 * rB0;
         rC2_0 += m2;
         m2 = rA2 * rB0;
         rC3_0 += m3;
         m3 = rA3 * rB0;
         rA0 = pA0[33];
         rB0 = pB0[33];
         rA1 = pA0[117];
         rA2 = pA0[201];
         rC0_0 += m0;
         m0 = rA0 * rB0;
         rA3 = pA0[285];
         rC1_0 += m1;
         m1 = rA1 * rB0;
         rC2_0 += m2;
         m2 = rA2 * rB0;
         rC3_0 += m3;
         m3 = rA3 * rB0;
         rA0 = pA0[34];
         rB0 = pB0[34];
         rA1 = pA0[118];
         rA2 = pA0[202];
         rC0_0 += m0;
         m0 = rA0 * rB0;
         rA3 = pA0[286];
         rC1_0 += m1;
         m1 = rA1 * rB0;
         rC2_0 += m2;
         m2 = rA2 * rB0;
         rC3_0 += m3;
         m3 = rA3 * rB0;
         rA0 = pA0[35];
         rB0 = pB0[35];
         rA1 = pA0[119];
         rA2 = pA0[203];
         rC0_0 += m0;
         m0 = rA0 * rB0;
         rA3 = pA0[287];
         rC1_0 += m1;
         m1 = rA1 * rB0;
         rC2_0 += m2;
         m2 = rA2 * rB0;
         rC3_0 += m3;
         m3 = rA3 * rB0;
         rA0 = pA0[36];
         rB0 = pB0[36];
         rA1 = pA0[120];
         rA2 = pA0[204];
         rC0_0 += m0;
         m0 = rA0 * rB0;
         rA3 = pA0[288];
         rC1_0 += m1;
         m1 = rA1 * rB0;
         rC2_0 += m2;
         m2 = rA2 * rB0;
         rC3_0 += m3;
         m3 = rA3 * rB0;
         rA0 = pA0[37];
         rB0 = pB0[37];
         rA1 = pA0[121];
         rA2 = pA0[205];
         rC0_0 += m0;
         m0 = rA0 * rB0;
         rA3 = pA0[289];
         rC1_0 += m1;
         m1 = rA1 * rB0;
         rC2_0 += m2;
         m2 = rA2 * rB0;
         rC3_0 += m3;
         m3 = rA3 * rB0;
         rA0 = pA0[38];
         rB0 = pB0[38];
         rA1 = pA0[122];
         rA2 = pA0[206];
         rC0_0 += m0;
         m0 = rA0 * rB0;
         rA3 = pA0[290];
         rC1_0 += m1;
         m1 = rA1 * rB0;
         rC2_0 += m2;
         m2 = rA2 * rB0;
         rC3_0 += m3;
         m3 = rA3 * rB0;
         rA0 = pA0[39];
         rB0 = pB0[39];
         rA1 = pA0[123];
         rA2 = pA0[207];
         rC0_0 += m0;
         m0 = rA0 * rB0;
         rA3 = pA0[291];
         rC1_0 += m1;
         m1 = rA1 * rB0;
         rC2_0 += m2;
         m2 = rA2 * rB0;
         rC3_0 += m3;
         m3 = rA3 * rB0;
         rA0 = pA0[40];
         rB0 = pB0[40];
         rA1 = pA0[124];
         rA2 = pA0[208];
         rC0_0 += m0;
         m0 = rA0 * rB0;
         rA3 = pA0[292];
         rC1_0 += m1;
         m1 = rA1 * rB0;
         rC2_0 += m2;
         m2 = rA2 * rB0;
         rC3_0 += m3;
         m3 = rA3 * rB0;
         rA0 = pA0[41];
         rB0 = pB0[41];
         rA1 = pA0[125];
         rA2 = pA0[209];
         rC0_0 += m0;
         m0 = rA0 * rB0;
         rA3 = pA0[293];
         rC1_0 += m1;
         m1 = rA1 * rB0;
         rC2_0 += m2;
         m2 = rA2 * rB0;
         rC3_0 += m3;
         m3 = rA3 * rB0;
         rA0 = pA0[42];
         rB0 = pB0[42];
         rA1 = pA0[126];
         rA2 = pA0[210];
         rC0_0 += m0;
         m0 = rA0 * rB0;
         rA3 = pA0[294];
         rC1_0 += m1;
         m1 = rA1 * rB0;
         rC2_0 += m2;
         m2 = rA2 * rB0;
         rC3_0 += m3;
         m3 = rA3 * rB0;
         rA0 = pA0[43];
         rB0 = pB0[43];
         rA1 = pA0[127];
         rA2 = pA0[211];
         rC0_0 += m0;
         m0 = rA0 * rB0;
         rA3 = pA0[295];
         rC1_0 += m1;
         m1 = rA1 * rB0;
         rC2_0 += m2;
         m2 = rA2 * rB0;
         rC3_0 += m3;
         m3 = rA3 * rB0;
         rA0 = pA0[44];
         rB0 = pB0[44];
         rA1 = pA0[128];
         rA2 = pA0[212];
         rC0_0 += m0;
         m0 = rA0 * rB0;
         rA3 = pA0[296];
         rC1_0 += m1;
         m1 = rA1 * rB0;
         rC2_0 += m2;
         m2 = rA2 * rB0;
         rC3_0 += m3;
         m3 = rA3 * rB0;
         rA0 = pA0[45];
         rB0 = pB0[45];
         rA1 = pA0[129];
         rA2 = pA0[213];
         rC0_0 += m0;
         m0 = rA0 * rB0;
         rA3 = pA0[297];
         rC1_0 += m1;
         m1 = rA1 * rB0;
         rC2_0 += m2;
         m2 = rA2 * rB0;
         rC3_0 += m3;
         m3 = rA3 * rB0;
         rA0 = pA0[46];
         rB0 = pB0[46];
         rA1 = pA0[130];
         rA2 = pA0[214];
         rC0_0 += m0;
         m0 = rA0 * rB0;
         rA3 = pA0[298];
         rC1_0 += m1;
         m1 = rA1 * rB0;
         rC2_0 += m2;
         m2 = rA2 * rB0;
         rC3_0 += m3;
         m3 = rA3 * rB0;
         rA0 = pA0[47];
         rB0 = pB0[47];
         rA1 = pA0[131];
         rA2 = pA0[215];
         rC0_0 += m0;
         m0 = rA0 * rB0;
         rA3 = pA0[299];
         rC1_0 += m1;
         m1 = rA1 * rB0;
         rC2_0 += m2;
         m2 = rA2 * rB0;
         rC3_0 += m3;
         m3 = rA3 * rB0;
         rA0 = pA0[48];
         rB0 = pB0[48];
         rA1 = pA0[132];
         rA2 = pA0[216];
         rC0_0 += m0;
         m0 = rA0 * rB0;
         rA3 = pA0[300];
         rC1_0 += m1;
         m1 = rA1 * rB0;
         rC2_0 += m2;
         m2 = rA2 * rB0;
         rC3_0 += m3;
         m3 = rA3 * rB0;
         rA0 = pA0[49];
         rB0 = pB0[49];
         rA1 = pA0[133];
         rA2 = pA0[217];
         rC0_0 += m0;
         m0 = rA0 * rB0;
         rA3 = pA0[301];
         rC1_0 += m1;
         m1 = rA1 * rB0;
         rC2_0 += m2;
         m2 = rA2 * rB0;
         rC3_0 += m3;
         m3 = rA3 * rB0;
         rA0 = pA0[50];
         rB0 = pB0[50];
         rA1 = pA0[134];
         rA2 = pA0[218];
         rC0_0 += m0;
         m0 = rA0 * rB0;
         rA3 = pA0[302];
         rC1_0 += m1;
         m1 = rA1 * rB0;
         rC2_0 += m2;
         m2 = rA2 * rB0;
         rC3_0 += m3;
         m3 = rA3 * rB0;
         rA0 = pA0[51];
         rB0 = pB0[51];
         rA1 = pA0[135];
         rA2 = pA0[219];
         rC0_0 += m0;
         m0 = rA0 * rB0;
         rA3 = pA0[303];
         rC1_0 += m1;
         m1 = rA1 * rB0;
         rC2_0 += m2;
         m2 = rA2 * rB0;
         rC3_0 += m3;
         m3 = rA3 * rB0;
         rA0 = pA0[52];
         rB0 = pB0[52];
         rA1 = pA0[136];
         rA2 = pA0[220];
         rC0_0 += m0;
         m0 = rA0 * rB0;
         rA3 = pA0[304];
         rC1_0 += m1;
         m1 = rA1 * rB0;
         rC2_0 += m2;
         m2 = rA2 * rB0;
         rC3_0 += m3;
         m3 = rA3 * rB0;
         rA0 = pA0[53];
         rB0 = pB0[53];
         rA1 = pA0[137];
         rA2 = pA0[221];
         rC0_0 += m0;
         m0 = rA0 * rB0;
         rA3 = pA0[305];
         rC1_0 += m1;
         m1 = rA1 * rB0;
         rC2_0 += m2;
         m2 = rA2 * rB0;
         rC3_0 += m3;
         m3 = rA3 * rB0;
         rA0 = pA0[54];
         rB0 = pB0[54];
         rA1 = pA0[138];
         rA2 = pA0[222];
         rC0_0 += m0;
         m0 = rA0 * rB0;
         rA3 = pA0[306];
         rC1_0 += m1;
         m1 = rA1 * rB0;
         rC2_0 += m2;
         m2 = rA2 * rB0;
         rC3_0 += m3;
         m3 = rA3 * rB0;
         rA0 = pA0[55];
         rB0 = pB0[55];
         rA1 = pA0[139];
         rA2 = pA0[223];
         rC0_0 += m0;
         m0 = rA0 * rB0;
         rA3 = pA0[307];
         rC1_0 += m1;
         m1 = rA1 * rB0;
         rC2_0 += m2;
         m2 = rA2 * rB0;
         rC3_0 += m3;
         m3 = rA3 * rB0;
         rA0 = pA0[56];
         rB0 = pB0[56];
         rA1 = pA0[140];
         rA2 = pA0[224];
         rC0_0 += m0;
         m0 = rA0 * rB0;
         rA3 = pA0[308];
         rC1_0 += m1;
         m1 = rA1 * rB0;
         rC2_0 += m2;
         m2 = rA2 * rB0;
         rC3_0 += m3;
         m3 = rA3 * rB0;
         rA0 = pA0[57];
         rB0 = pB0[57];
         rA1 = pA0[141];
         rA2 = pA0[225];
         rC0_0 += m0;
         m0 = rA0 * rB0;
         rA3 = pA0[309];
         rC1_0 += m1;
         m1 = rA1 * rB0;
         rC2_0 += m2;
         m2 = rA2 * rB0;
         rC3_0 += m3;
         m3 = rA3 * rB0;
         rA0 = pA0[58];
         rB0 = pB0[58];
         rA1 = pA0[142];
         rA2 = pA0[226];
         rC0_0 += m0;
         m0 = rA0 * rB0;
         rA3 = pA0[310];
         rC1_0 += m1;
         m1 = rA1 * rB0;
         rC2_0 += m2;
         m2 = rA2 * rB0;
         rC3_0 += m3;
         m3 = rA3 * rB0;
         rA0 = pA0[59];
         rB0 = pB0[59];
         rA1 = pA0[143];
         rA2 = pA0[227];
         rC0_0 += m0;
         m0 = rA0 * rB0;
         rA3 = pA0[311];
         rC1_0 += m1;
         m1 = rA1 * rB0;
         rC2_0 += m2;
         m2 = rA2 * rB0;
         rC3_0 += m3;
         m3 = rA3 * rB0;
         rA0 = pA0[60];
         rB0 = pB0[60];
         rA1 = pA0[144];
         rA2 = pA0[228];
         rC0_0 += m0;
         m0 = rA0 * rB0;
         rA3 = pA0[312];
         rC1_0 += m1;
         m1 = rA1 * rB0;
         rC2_0 += m2;
         m2 = rA2 * rB0;
         rC3_0 += m3;
         m3 = rA3 * rB0;
         rA0 = pA0[61];
         rB0 = pB0[61];
         rA1 = pA0[145];
         rA2 = pA0[229];
         rC0_0 += m0;
         m0 = rA0 * rB0;
         rA3 = pA0[313];
         rC1_0 += m1;
         m1 = rA1 * rB0;
         rC2_0 += m2;
         m2 = rA2 * rB0;
         rC3_0 += m3;
         m3 = rA3 * rB0;
         rA0 = pA0[62];
         rB0 = pB0[62];
         rA1 = pA0[146];
         rA2 = pA0[230];
         rC0_0 += m0;
         m0 = rA0 * rB0;
         rA3 = pA0[314];
         rC1_0 += m1;
         m1 = rA1 * rB0;
         rC2_0 += m2;
         m2 = rA2 * rB0;
         rC3_0 += m3;
         m3 = rA3 * rB0;
         rA0 = pA0[63];
         rB0 = pB0[63];
         rA1 = pA0[147];
         rA2 = pA0[231];
         rC0_0 += m0;
         m0 = rA0 * rB0;
         rA3 = pA0[315];
         rC1_0 += m1;
         m1 = rA1 * rB0;
         rC2_0 += m2;
         m2 = rA2 * rB0;
         rC3_0 += m3;
         m3 = rA3 * rB0;
         rA0 = pA0[64];
         rB0 = pB0[64];
         rA1 = pA0[148];
         rA2 = pA0[232];
         rC0_0 += m0;
         m0 = rA0 * rB0;
         rA3 = pA0[316];
         rC1_0 += m1;
         m1 = rA1 * rB0;
         rC2_0 += m2;
         m2 = rA2 * rB0;
         rC3_0 += m3;
         m3 = rA3 * rB0;
         rA0 = pA0[65];
         rB0 = pB0[65];
         rA1 = pA0[149];
         rA2 = pA0[233];
         rC0_0 += m0;
         m0 = rA0 * rB0;
         rA3 = pA0[317];
         rC1_0 += m1;
         m1 = rA1 * rB0;
         rC2_0 += m2;
         m2 = rA2 * rB0;
         rC3_0 += m3;
         m3 = rA3 * rB0;
         rA0 = pA0[66];
         rB0 = pB0[66];
         rA1 = pA0[150];
         rA2 = pA0[234];
         rC0_0 += m0;
         m0 = rA0 * rB0;
         rA3 = pA0[318];
         rC1_0 += m1;
         m1 = rA1 * rB0;
         rC2_0 += m2;
         m2 = rA2 * rB0;
         rC3_0 += m3;
         m3 = rA3 * rB0;
         rA0 = pA0[67];
         rB0 = pB0[67];
         rA1 = pA0[151];
         rA2 = pA0[235];
         rC0_0 += m0;
         m0 = rA0 * rB0;
         rA3 = pA0[319];
         rC1_0 += m1;
         m1 = rA1 * rB0;
         rC2_0 += m2;
         m2 = rA2 * rB0;
         rC3_0 += m3;
         m3 = rA3 * rB0;
         rA0 = pA0[68];
         rB0 = pB0[68];
         rA1 = pA0[152];
         rA2 = pA0[236];
         rC0_0 += m0;
         m0 = rA0 * rB0;
         rA3 = pA0[320];
         rC1_0 += m1;
         m1 = rA1 * rB0;
         rC2_0 += m2;
         m2 = rA2 * rB0;
         rC3_0 += m3;
         m3 = rA3 * rB0;
         rA0 = pA0[69];
         rB0 = pB0[69];
         rA1 = pA0[153];
         rA2 = pA0[237];
         rC0_0 += m0;
         m0 = rA0 * rB0;
         rA3 = pA0[321];
         rC1_0 += m1;
         m1 = rA1 * rB0;
         rC2_0 += m2;
         m2 = rA2 * rB0;
         rC3_0 += m3;
         m3 = rA3 * rB0;
         rA0 = pA0[70];
         rB0 = pB0[70];
         rA1 = pA0[154];
         rA2 = pA0[238];
         rC0_0 += m0;
         m0 = rA0 * rB0;
         rA3 = pA0[322];
         rC1_0 += m1;
         m1 = rA1 * rB0;
         rC2_0 += m2;
         m2 = rA2 * rB0;
         rC3_0 += m3;
         m3 = rA3 * rB0;
         rA0 = pA0[71];
         rB0 = pB0[71];
         rA1 = pA0[155];
         rA2 = pA0[239];
         rC0_0 += m0;
         m0 = rA0 * rB0;
         rA3 = pA0[323];
         rC1_0 += m1;
         m1 = rA1 * rB0;
         rC2_0 += m2;
         m2 = rA2 * rB0;
         rC3_0 += m3;
         m3 = rA3 * rB0;
         rA0 = pA0[72];
         rB0 = pB0[72];
         rA1 = pA0[156];
         rA2 = pA0[240];
         rC0_0 += m0;
         m0 = rA0 * rB0;
         rA3 = pA0[324];
         rC1_0 += m1;
         m1 = rA1 * rB0;
         rC2_0 += m2;
         m2 = rA2 * rB0;
         rC3_0 += m3;
         m3 = rA3 * rB0;
         rA0 = pA0[73];
         rB0 = pB0[73];
         rA1 = pA0[157];
         rA2 = pA0[241];
         rC0_0 += m0;
         m0 = rA0 * rB0;
         rA3 = pA0[325];
         rC1_0 += m1;
         m1 = rA1 * rB0;
         rC2_0 += m2;
         m2 = rA2 * rB0;
         rC3_0 += m3;
         m3 = rA3 * rB0;
         rA0 = pA0[74];
         rB0 = pB0[74];
         rA1 = pA0[158];
         rA2 = pA0[242];
         rC0_0 += m0;
         m0 = rA0 * rB0;
         rA3 = pA0[326];
         rC1_0 += m1;
         m1 = rA1 * rB0;
         rC2_0 += m2;
         m2 = rA2 * rB0;
         rC3_0 += m3;
         m3 = rA3 * rB0;
         rA0 = pA0[75];
         rB0 = pB0[75];
         rA1 = pA0[159];
         rA2 = pA0[243];
         rC0_0 += m0;
         m0 = rA0 * rB0;
         rA3 = pA0[327];
         rC1_0 += m1;
         m1 = rA1 * rB0;
         rC2_0 += m2;
         m2 = rA2 * rB0;
         rC3_0 += m3;
         m3 = rA3 * rB0;
         rA0 = pA0[76];
         rB0 = pB0[76];
         rA1 = pA0[160];
         rA2 = pA0[244];
         rC0_0 += m0;
         m0 = rA0 * rB0;
         rA3 = pA0[328];
         rC1_0 += m1;
         m1 = rA1 * rB0;
         rC2_0 += m2;
         m2 = rA2 * rB0;
         rC3_0 += m3;
         m3 = rA3 * rB0;
         rA0 = pA0[77];
         rB0 = pB0[77];
         rA1 = pA0[161];
         rA2 = pA0[245];
         rC0_0 += m0;
         m0 = rA0 * rB0;
         rA3 = pA0[329];
         rC1_0 += m1;
         m1 = rA1 * rB0;
         rC2_0 += m2;
         m2 = rA2 * rB0;
         rC3_0 += m3;
         m3 = rA3 * rB0;
         rA0 = pA0[78];
         rB0 = pB0[78];
         rA1 = pA0[162];
         rA2 = pA0[246];
         rC0_0 += m0;
         m0 = rA0 * rB0;
         rA3 = pA0[330];
         rC1_0 += m1;
         m1 = rA1 * rB0;
         rC2_0 += m2;
         m2 = rA2 * rB0;
         rC3_0 += m3;
         m3 = rA3 * rB0;
         rA0 = pA0[79];
         rB0 = pB0[79];
         rA1 = pA0[163];
         rA2 = pA0[247];
         rC0_0 += m0;
         m0 = rA0 * rB0;
         rA3 = pA0[331];
         rC1_0 += m1;
         m1 = rA1 * rB0;
         rC2_0 += m2;
         m2 = rA2 * rB0;
         rC3_0 += m3;
         m3 = rA3 * rB0;
         rA0 = pA0[80];
         rB0 = pB0[80];
         rA1 = pA0[164];
         rA2 = pA0[248];
         rC0_0 += m0;
         m0 = rA0 * rB0;
         rA3 = pA0[332];
         rC1_0 += m1;
         m1 = rA1 * rB0;
         rC2_0 += m2;
         m2 = rA2 * rB0;
         rC3_0 += m3;
         m3 = rA3 * rB0;
         rA0 = pA0[81];
         rB0 = pB0[81];
         rA1 = pA0[165];
         rA2 = pA0[249];
         rC0_0 += m0;
         m0 = rA0 * rB0;
         rA3 = pA0[333];
         rC1_0 += m1;
         m1 = rA1 * rB0;
         rC2_0 += m2;
         m2 = rA2 * rB0;
         rC3_0 += m3;
         m3 = rA3 * rB0;
         rA0 = pA0[82];
         rB0 = pB0[82];
         rA1 = pA0[166];
         rA2 = pA0[250];
         rC0_0 += m0;
         m0 = rA0 * rB0;
         rA3 = pA0[334];
         rC1_0 += m1;
         m1 = rA1 * rB0;
         rC2_0 += m2;
         m2 = rA2 * rB0;
         rC3_0 += m3;
         m3 = rA3 * rB0;
         rA0 = pA0[83];
         rB0 = pB0[83];
         rA1 = pA0[167];
         rA2 = pA0[251];
/*
 *       Drain pipe on last iteration of K-loop
 */
         rC0_0 += m0;
         m0 = rA0 * rB0;
         rA3 = pA0[335];
         rC1_0 += m1;
         m1 = rA1 * rB0;
         rC2_0 += m2;
         m2 = rA2 * rB0;
         rC3_0 += m3;
         m3 = rA3 * rB0;
         rC0_0 += m0;
         rC1_0 += m1;
         rC2_0 += m2;
         rC3_0 += m3;
         pA0 += incAk;
         pB0 += incBk;
         *pC0 = rC0_0;
         pC0[2] = rC1_0;
         pC0[4] = rC2_0;
         pC0[6] = rC3_0;
         pC0 += incCm;
         pA0 += incAm;
         pB0 += incBm;
      }
      while(pA0 != stM);
      pC0 += incCn;
      pA0 += incAn;
      pB0 += incBn;
   }
   while(pB0 != stN);
}
#ifdef incAm
   #undef incAm
#endif
#ifdef incAn
   #undef incAn
#endif
#ifdef incAk
   #undef incAk
#endif
#ifdef incBm
   #undef incBm
#endif
#ifdef incBn
   #undef incBn
#endif
#ifdef incBk
   #undef incBk
#endif
#ifdef incCm
   #undef incCm
#endif
#ifdef incCn
   #undef incCn
#endif
#ifdef incCk
   #undef incCk
#endif
#ifdef Mb
   #undef Mb
#endif
#ifdef Nb
   #undef Nb
#endif
#ifdef Kb
   #undef Kb
#endif
#ifdef ATL_UCLEANN
#define ATL_cpNBmm_b0 ATL_cgpNBmm_b0
#endif

void ATL_cJIK84x0x84TN84x84x0_a1_b0(const int M, const int N, const int K, const float alpha, const float *A, const int lda, const float *B, const int ldb, const float beta, float *C, const int ldc);
void ATL_cJIK84x0x84TN84x84x0_a1_bX(const int M, const int N, const int K, const float alpha, const float *A, const int lda, const float *B, const int ldb, const float beta, float *C, const int ldc);
void ATL_cJIK84x0x84TN84x84x0_a1_b1(const int M, const int N, const int K, const float alpha, const float *A, const int lda, const float *B, const int ldb, const float beta, float *C, const int ldc);

void ATL_cpNBmm_b0(const int M, const int N, const int K, const float alpha, const float *A, const int lda, const float *B, const int ldb, const float beta, float *C, const int ldc)
{
   ATL_cJIK84x0x84TN84x84x0_a1_b0(M, N, K, alpha, A, lda, B, ldb, -beta, C, ldc);
   ATL_cJIK84x0x84TN84x84x0_a1_b0(M, N, K, alpha, A, lda, B+N*ldb, ldb, beta, C+1, ldc);
   ATL_cJIK84x0x84TN84x84x0_a1_bX(M, N, K, alpha, A+M*lda, lda, B+N*ldb, ldb, -1.0, C, ldc);
   ATL_cJIK84x0x84TN84x84x0_a1_b1(M, N, K, alpha, A+M*lda, lda, B, ldb, 1.0, C+1, ldc);
}
