#ifndef ATL_RESTRICT
#if defined(__STDC_VERSION__) && (__STDC_VERSION__/100 >= 1999)
   #define ATL_RESTRICT restrict
#else
   #define ATL_RESTRICT
#endif
#endif
#include "atlas_prefetch.h"

void ATL_sJIK24x24x24NN0x0x0_a1_b1
   (const int M, const int N, const int K, const float alpha, const float * ATL_RESTRICT A, const int lda, const float * ATL_RESTRICT B, const int ldb, const float beta, float * ATL_RESTRICT C, const int ldc)
/*
 * matmul with TA=N, TB=N, MB=24, NB=24, KB=24, 
 * lda=0, ldb=0, ldc=0, mu=4, nu=1, ku=24, pf=1
 * Generated by ATLAS/tune/blas/gemm/emit_mm.c (3.10.3)
 */
{
   const float *stM = A + 24;
   const float *stN = B + (((ldb) << 4)+((ldb) << 3));
   const float *pfA = A + lda*M;
   const int incAk = (lda);
   const int incAm = 4 - (((lda) << 4)+((lda) << 3)), incAn = -24;
   #define incBk 24
   const int incBm = -24, incBn = (ldb);
   #define incAk0 incAk
   const int incBk0 = ((incBk) / 24);
   #define incCm 4
   const int incCn = (ldc) - 24;
   float *pC0=C;
   const float *pA0=A;
   const float *pB0=B;
   register int k;
   register float rA0, rA1, rA2, rA3;
   register float rB0;
   register float m0, m1, m2;
   register float rC0_0, rC1_0, rC2_0, rC3_0;
   do /* N-loop */
   {
      ATL_pfl1R(pfA+0);
      pfA += lda;
      do /* M-loop */
      {
         rC0_0 = *pC0;
         rC1_0 = pC0[1];
         rC2_0 = pC0[2];
         rC3_0 = pC0[3];
/*
 *       Start pipeline
 */
         rA0 = *pA0;
         rB0 = *pB0;
         m0 = rA0 * rB0;
         rA1 = pA0[1];
         rA2 = pA0[2];
         m1 = rA1 * rB0;
         rA3 = pA0[3];
         m2 = rA2 * rB0;

/*
 *       Completely unrolled K-loop
 */
         rC0_0 += m0;
         m0 = rA3 * rB0;
         pA0 += incAk;
         rA0 = *pA0;
         rB0 = pB0[1];
         rA1 = pA0[1];
         rA2 = pA0[2];
         rC1_0 += m1;
         m1 = rA0 * rB0;
         rA3 = pA0[3];
         rC2_0 += m2;
         m2 = rA1 * rB0;
         rC3_0 += m0;
         m0 = rA2 * rB0;
         rC0_0 += m1;
         m1 = rA3 * rB0;
         pA0 += incAk;
         rA0 = *pA0;
         rB0 = pB0[2];
         rA1 = pA0[1];
         rA2 = pA0[2];
         rC1_0 += m2;
         m2 = rA0 * rB0;
         rA3 = pA0[3];
         rC2_0 += m0;
         m0 = rA1 * rB0;
         rC3_0 += m1;
         m1 = rA2 * rB0;
         rC0_0 += m2;
         m2 = rA3 * rB0;
         pA0 += incAk;
         rA0 = *pA0;
         rB0 = pB0[3];
         rA1 = pA0[1];
         rA2 = pA0[2];
         rC1_0 += m0;
         m0 = rA0 * rB0;
         rA3 = pA0[3];
         rC2_0 += m1;
         m1 = rA1 * rB0;
         rC3_0 += m2;
         m2 = rA2 * rB0;
         rC0_0 += m0;
         m0 = rA3 * rB0;
         pA0 += incAk;
         rA0 = *pA0;
         rB0 = pB0[4];
         rA1 = pA0[1];
         rA2 = pA0[2];
         rC1_0 += m1;
         m1 = rA0 * rB0;
         rA3 = pA0[3];
         rC2_0 += m2;
         m2 = rA1 * rB0;
         rC3_0 += m0;
         m0 = rA2 * rB0;
         rC0_0 += m1;
         m1 = rA3 * rB0;
         pA0 += incAk;
         rA0 = *pA0;
         rB0 = pB0[5];
         rA1 = pA0[1];
         rA2 = pA0[2];
         rC1_0 += m2;
         m2 = rA0 * rB0;
         rA3 = pA0[3];
         rC2_0 += m0;
         m0 = rA1 * rB0;
         rC3_0 += m1;
         m1 = rA2 * rB0;
         rC0_0 += m2;
         m2 = rA3 * rB0;
         pA0 += incAk;
         rA0 = *pA0;
         rB0 = pB0[6];
         rA1 = pA0[1];
         rA2 = pA0[2];
         rC1_0 += m0;
         m0 = rA0 * rB0;
         rA3 = pA0[3];
         rC2_0 += m1;
         m1 = rA1 * rB0;
         rC3_0 += m2;
         m2 = rA2 * rB0;
         rC0_0 += m0;
         m0 = rA3 * rB0;
         pA0 += incAk;
         rA0 = *pA0;
         rB0 = pB0[7];
         rA1 = pA0[1];
         rA2 = pA0[2];
         rC1_0 += m1;
         m1 = rA0 * rB0;
         rA3 = pA0[3];
         rC2_0 += m2;
         m2 = rA1 * rB0;
         rC3_0 += m0;
         m0 = rA2 * rB0;
         rC0_0 += m1;
         m1 = rA3 * rB0;
         pA0 += incAk;
         rA0 = *pA0;
         rB0 = pB0[8];
         rA1 = pA0[1];
         rA2 = pA0[2];
         rC1_0 += m2;
         m2 = rA0 * rB0;
         rA3 = pA0[3];
         rC2_0 += m0;
         m0 = rA1 * rB0;
         rC3_0 += m1;
         m1 = rA2 * rB0;
         rC0_0 += m2;
         m2 = rA3 * rB0;
         pA0 += incAk;
         rA0 = *pA0;
         rB0 = pB0[9];
         rA1 = pA0[1];
         rA2 = pA0[2];
         rC1_0 += m0;
         m0 = rA0 * rB0;
         rA3 = pA0[3];
         rC2_0 += m1;
         m1 = rA1 * rB0;
         rC3_0 += m2;
         m2 = rA2 * rB0;
         rC0_0 += m0;
         m0 = rA3 * rB0;
         pA0 += incAk;
         rA0 = *pA0;
         rB0 = pB0[10];
         rA1 = pA0[1];
         rA2 = pA0[2];
         rC1_0 += m1;
         m1 = rA0 * rB0;
         rA3 = pA0[3];
         rC2_0 += m2;
         m2 = rA1 * rB0;
         rC3_0 += m0;
         m0 = rA2 * rB0;
         rC0_0 += m1;
         m1 = rA3 * rB0;
         pA0 += incAk;
         rA0 = *pA0;
         rB0 = pB0[11];
         rA1 = pA0[1];
         rA2 = pA0[2];
         rC1_0 += m2;
         m2 = rA0 * rB0;
         rA3 = pA0[3];
         rC2_0 += m0;
         m0 = rA1 * rB0;
         rC3_0 += m1;
         m1 = rA2 * rB0;
         rC0_0 += m2;
         m2 = rA3 * rB0;
         pA0 += incAk;
         rA0 = *pA0;
         rB0 = pB0[12];
         rA1 = pA0[1];
         rA2 = pA0[2];
         rC1_0 += m0;
         m0 = rA0 * rB0;
         rA3 = pA0[3];
         rC2_0 += m1;
         m1 = rA1 * rB0;
         rC3_0 += m2;
         m2 = rA2 * rB0;
         rC0_0 += m0;
         m0 = rA3 * rB0;
         pA0 += incAk;
         rA0 = *pA0;
         rB0 = pB0[13];
         rA1 = pA0[1];
         rA2 = pA0[2];
         rC1_0 += m1;
         m1 = rA0 * rB0;
         rA3 = pA0[3];
         rC2_0 += m2;
         m2 = rA1 * rB0;
         rC3_0 += m0;
         m0 = rA2 * rB0;
         rC0_0 += m1;
         m1 = rA3 * rB0;
         pA0 += incAk;
         rA0 = *pA0;
         rB0 = pB0[14];
         rA1 = pA0[1];
         rA2 = pA0[2];
         rC1_0 += m2;
         m2 = rA0 * rB0;
         rA3 = pA0[3];
         rC2_0 += m0;
         m0 = rA1 * rB0;
         rC3_0 += m1;
         m1 = rA2 * rB0;
         rC0_0 += m2;
         m2 = rA3 * rB0;
         pA0 += incAk;
         rA0 = *pA0;
         rB0 = pB0[15];
         rA1 = pA0[1];
         rA2 = pA0[2];
         rC1_0 += m0;
         m0 = rA0 * rB0;
         rA3 = pA0[3];
         rC2_0 += m1;
         m1 = rA1 * rB0;
         rC3_0 += m2;
         m2 = rA2 * rB0;
         rC0_0 += m0;
         m0 = rA3 * rB0;
         pA0 += incAk;
         rA0 = *pA0;
         rB0 = pB0[16];
         rA1 = pA0[1];
         rA2 = pA0[2];
         rC1_0 += m1;
         m1 = rA0 * rB0;
         rA3 = pA0[3];
         rC2_0 += m2;
         m2 = rA1 * rB0;
         rC3_0 += m0;
         m0 = rA2 * rB0;
         rC0_0 += m1;
         m1 = rA3 * rB0;
         pA0 += incAk;
         rA0 = *pA0;
         rB0 = pB0[17];
         rA1 = pA0[1];
         rA2 = pA0[2];
         rC1_0 += m2;
         m2 = rA0 * rB0;
         rA3 = pA0[3];
         rC2_0 += m0;
         m0 = rA1 * rB0;
         rC3_0 += m1;
         m1 = rA2 * rB0;
         rC0_0 += m2;
         m2 = rA3 * rB0;
         pA0 += incAk;
         rA0 = *pA0;
         rB0 = pB0[18];
         rA1 = pA0[1];
         rA2 = pA0[2];
         rC1_0 += m0;
         m0 = rA0 * rB0;
         rA3 = pA0[3];
         rC2_0 += m1;
         m1 = rA1 * rB0;
         rC3_0 += m2;
         m2 = rA2 * rB0;
         rC0_0 += m0;
         m0 = rA3 * rB0;
         pA0 += incAk;
         rA0 = *pA0;
         rB0 = pB0[19];
         rA1 = pA0[1];
         rA2 = pA0[2];
         rC1_0 += m1;
         m1 = rA0 * rB0;
         rA3 = pA0[3];
         rC2_0 += m2;
         m2 = rA1 * rB0;
         rC3_0 += m0;
         m0 = rA2 * rB0;
         rC0_0 += m1;
         m1 = rA3 * rB0;
         pA0 += incAk;
         rA0 = *pA0;
         rB0 = pB0[20];
         rA1 = pA0[1];
         rA2 = pA0[2];
         rC1_0 += m2;
         m2 = rA0 * rB0;
         rA3 = pA0[3];
         rC2_0 += m0;
         m0 = rA1 * rB0;
         rC3_0 += m1;
         m1 = rA2 * rB0;
         rC0_0 += m2;
         m2 = rA3 * rB0;
         pA0 += incAk;
         rA0 = *pA0;
         rB0 = pB0[21];
         rA1 = pA0[1];
         rA2 = pA0[2];
         rC1_0 += m0;
         m0 = rA0 * rB0;
         rA3 = pA0[3];
         rC2_0 += m1;
         m1 = rA1 * rB0;
         rC3_0 += m2;
         m2 = rA2 * rB0;
         rC0_0 += m0;
         m0 = rA3 * rB0;
         pA0 += incAk;
         rA0 = *pA0;
         rB0 = pB0[22];
         rA1 = pA0[1];
         rA2 = pA0[2];
         rC1_0 += m1;
         m1 = rA0 * rB0;
         rA3 = pA0[3];
         rC2_0 += m2;
         m2 = rA1 * rB0;
         rC3_0 += m0;
         m0 = rA2 * rB0;
         rC0_0 += m1;
         m1 = rA3 * rB0;
         pA0 += incAk;
         rA0 = *pA0;
         rB0 = pB0[23];
         rA1 = pA0[1];
         rA2 = pA0[2];
         rC1_0 += m2;
         m2 = rA0 * rB0;
         rA3 = pA0[3];
         rC2_0 += m0;
         m0 = rA1 * rB0;
         rC3_0 += m1;
         m1 = rA2 * rB0;
/*
 *       Drain pipe on last iteration of K-loop
 */
         rC0_0 += m2;
         m2 = rA3 * rB0;
         pA0 += incAk;
         rC1_0 += m0;
         rC2_0 += m1;
         rC3_0 += m2;
         pB0 += incBk;
         *pC0 = rC0_0;
         pC0[1] = rC1_0;
         pC0[2] = rC2_0;
         pC0[3] = rC3_0;
         pC0 += incCm;
         pA0 += incAm;
         pB0 += incBm;
      }
      while(pA0 != stM);
      pC0 += incCn;
      pA0 += incAn;
      pB0 += incBn;
   }
   while(pB0 != stN);
}
#ifdef incAm
   #undef incAm
#endif
#ifdef incAn
   #undef incAn
#endif
#ifdef incAk
   #undef incAk
#endif
#ifdef incBm
   #undef incBm
#endif
#ifdef incBn
   #undef incBn
#endif
#ifdef incBk
   #undef incBk
#endif
#ifdef incCm
   #undef incCm
#endif
#ifdef incCn
   #undef incCn
#endif
#ifdef incCk
   #undef incCk
#endif
#ifdef Mb
   #undef Mb
#endif
#ifdef Nb
   #undef Nb
#endif
#ifdef Kb
   #undef Kb
#endif
