#ifndef ATL_RESTRICT
#if defined(__STDC_VERSION__) && (__STDC_VERSION__/100 >= 1999)
   #define ATL_RESTRICT restrict
#else
   #define ATL_RESTRICT
#endif
#endif
#include "atlas_prefetch.h"

#ifndef ATL_RESTRICT
#if defined(__STDC_VERSION__) && (__STDC_VERSION__/100 >= 1999)
   #define ATL_RESTRICT restrict
#else
   #define ATL_RESTRICT
#endif
#endif
#include "atlas_prefetch.h"

static void ATL_sJIK0x0x0TT1x1x12_aX_bX
   (const int M, const int N, const int K, const float alpha, const float * ATL_RESTRICT A, const int lda, const float * ATL_RESTRICT B, const int ldb, const float beta, float * ATL_RESTRICT C, const int ldc)
/*
 * matmul with TA=T, TB=T, MB=0, NB=0, KB=0, 
 * lda=0, ldb=0, ldc=0, mu=1, nu=1, ku=12, pf=1
 * Generated by ATLAS/tune/blas/gemm/emit_mm.c (3.10.3)
 */
{
   #define Mb M
   #define Nb N
   const int Kb = (K/12)*12;
   const float *stM = A + (lda*Mb);
   const float *stN = B + (Nb);
   const float *pfA = A + M;
   const float BetaAlpha = beta / alpha;
   #define incAk 12
   const int incAm = ((lda) - Kb), incAn = -(Mb*lda);
   const int incBk = (ldb), incBm = -(Kb*ldb);
   #define incBn 1
   #define incCm 1
   const int incCn = (ldc) - (Mb);
   float *pC0=C;
   const float *pA0=A;
   const float *pB0=B;
   register int k;
   register float rA0;
   register float rB0;
   register float rC0_0;
   do /* N-loop */
   {
      ATL_pfl1R(pfA+0);
      ATL_pfl1R(pfA+16);
      pfA += lda;
      do /* M-loop */
      {
         rA0 = BetaAlpha;
         rC0_0 = *pC0;
         rC0_0 *= rA0;
         for (k=0; k < Kb; k += 12) /* easy loop to unroll */
         {
            rA0 = *pA0;
            rB0 = *pB0;
            rC0_0 += rA0 * rB0;
            pB0 += incBk;
            rA0 = pA0[1];
            rB0 = *pB0;
            rC0_0 += rA0 * rB0;
            pB0 += incBk;
            rA0 = pA0[2];
            rB0 = *pB0;
            rC0_0 += rA0 * rB0;
            pB0 += incBk;
            rA0 = pA0[3];
            rB0 = *pB0;
            rC0_0 += rA0 * rB0;
            pB0 += incBk;
            rA0 = pA0[4];
            rB0 = *pB0;
            rC0_0 += rA0 * rB0;
            pB0 += incBk;
            rA0 = pA0[5];
            rB0 = *pB0;
            rC0_0 += rA0 * rB0;
            pB0 += incBk;
            rA0 = pA0[6];
            rB0 = *pB0;
            rC0_0 += rA0 * rB0;
            pB0 += incBk;
            rA0 = pA0[7];
            rB0 = *pB0;
            rC0_0 += rA0 * rB0;
            pB0 += incBk;
            rA0 = pA0[8];
            rB0 = *pB0;
            rC0_0 += rA0 * rB0;
            pB0 += incBk;
            rA0 = pA0[9];
            rB0 = *pB0;
            rC0_0 += rA0 * rB0;
            pB0 += incBk;
            rA0 = pA0[10];
            rB0 = *pB0;
            rC0_0 += rA0 * rB0;
            pB0 += incBk;
            rA0 = pA0[11];
            rB0 = *pB0;
            rC0_0 += rA0 * rB0;
            pB0 += incBk;
            pA0 += incAk;
         }
         switch(k = (K-Kb))
         {
         case 1:
            rA0 = *pA0;
            rB0 = *pB0;
            rC0_0 += rA0 * rB0;
            pB0 += incBk;
            break;
         case 2:
            rA0 = *pA0;
            rB0 = *pB0;
            rC0_0 += rA0 * rB0;
            pB0 += incBk;
            rA0 = pA0[1];
            rB0 = *pB0;
            rC0_0 += rA0 * rB0;
            pB0 += incBk;
            break;
         case 3:
            rA0 = *pA0;
            rB0 = *pB0;
            rC0_0 += rA0 * rB0;
            pB0 += incBk;
            rA0 = pA0[1];
            rB0 = *pB0;
            rC0_0 += rA0 * rB0;
            pB0 += incBk;
            rA0 = pA0[2];
            rB0 = *pB0;
            rC0_0 += rA0 * rB0;
            pB0 += incBk;
            break;
         case 4:
            rA0 = *pA0;
            rB0 = *pB0;
            rC0_0 += rA0 * rB0;
            pB0 += incBk;
            rA0 = pA0[1];
            rB0 = *pB0;
            rC0_0 += rA0 * rB0;
            pB0 += incBk;
            rA0 = pA0[2];
            rB0 = *pB0;
            rC0_0 += rA0 * rB0;
            pB0 += incBk;
            rA0 = pA0[3];
            rB0 = *pB0;
            rC0_0 += rA0 * rB0;
            pB0 += incBk;
            break;
         case 5:
            rA0 = *pA0;
            rB0 = *pB0;
            rC0_0 += rA0 * rB0;
            pB0 += incBk;
            rA0 = pA0[1];
            rB0 = *pB0;
            rC0_0 += rA0 * rB0;
            pB0 += incBk;
            rA0 = pA0[2];
            rB0 = *pB0;
            rC0_0 += rA0 * rB0;
            pB0 += incBk;
            rA0 = pA0[3];
            rB0 = *pB0;
            rC0_0 += rA0 * rB0;
            pB0 += incBk;
            rA0 = pA0[4];
            rB0 = *pB0;
            rC0_0 += rA0 * rB0;
            pB0 += incBk;
            break;
         case 6:
            rA0 = *pA0;
            rB0 = *pB0;
            rC0_0 += rA0 * rB0;
            pB0 += incBk;
            rA0 = pA0[1];
            rB0 = *pB0;
            rC0_0 += rA0 * rB0;
            pB0 += incBk;
            rA0 = pA0[2];
            rB0 = *pB0;
            rC0_0 += rA0 * rB0;
            pB0 += incBk;
            rA0 = pA0[3];
            rB0 = *pB0;
            rC0_0 += rA0 * rB0;
            pB0 += incBk;
            rA0 = pA0[4];
            rB0 = *pB0;
            rC0_0 += rA0 * rB0;
            pB0 += incBk;
            rA0 = pA0[5];
            rB0 = *pB0;
            rC0_0 += rA0 * rB0;
            pB0 += incBk;
            break;
         case 7:
            rA0 = *pA0;
            rB0 = *pB0;
            rC0_0 += rA0 * rB0;
            pB0 += incBk;
            rA0 = pA0[1];
            rB0 = *pB0;
            rC0_0 += rA0 * rB0;
            pB0 += incBk;
            rA0 = pA0[2];
            rB0 = *pB0;
            rC0_0 += rA0 * rB0;
            pB0 += incBk;
            rA0 = pA0[3];
            rB0 = *pB0;
            rC0_0 += rA0 * rB0;
            pB0 += incBk;
            rA0 = pA0[4];
            rB0 = *pB0;
            rC0_0 += rA0 * rB0;
            pB0 += incBk;
            rA0 = pA0[5];
            rB0 = *pB0;
            rC0_0 += rA0 * rB0;
            pB0 += incBk;
            rA0 = pA0[6];
            rB0 = *pB0;
            rC0_0 += rA0 * rB0;
            pB0 += incBk;
            break;
         case 8:
            rA0 = *pA0;
            rB0 = *pB0;
            rC0_0 += rA0 * rB0;
            pB0 += incBk;
            rA0 = pA0[1];
            rB0 = *pB0;
            rC0_0 += rA0 * rB0;
            pB0 += incBk;
            rA0 = pA0[2];
            rB0 = *pB0;
            rC0_0 += rA0 * rB0;
            pB0 += incBk;
            rA0 = pA0[3];
            rB0 = *pB0;
            rC0_0 += rA0 * rB0;
            pB0 += incBk;
            rA0 = pA0[4];
            rB0 = *pB0;
            rC0_0 += rA0 * rB0;
            pB0 += incBk;
            rA0 = pA0[5];
            rB0 = *pB0;
            rC0_0 += rA0 * rB0;
            pB0 += incBk;
            rA0 = pA0[6];
            rB0 = *pB0;
            rC0_0 += rA0 * rB0;
            pB0 += incBk;
            rA0 = pA0[7];
            rB0 = *pB0;
            rC0_0 += rA0 * rB0;
            pB0 += incBk;
            break;
         case 9:
            rA0 = *pA0;
            rB0 = *pB0;
            rC0_0 += rA0 * rB0;
            pB0 += incBk;
            rA0 = pA0[1];
            rB0 = *pB0;
            rC0_0 += rA0 * rB0;
            pB0 += incBk;
            rA0 = pA0[2];
            rB0 = *pB0;
            rC0_0 += rA0 * rB0;
            pB0 += incBk;
            rA0 = pA0[3];
            rB0 = *pB0;
            rC0_0 += rA0 * rB0;
            pB0 += incBk;
            rA0 = pA0[4];
            rB0 = *pB0;
            rC0_0 += rA0 * rB0;
            pB0 += incBk;
            rA0 = pA0[5];
            rB0 = *pB0;
            rC0_0 += rA0 * rB0;
            pB0 += incBk;
            rA0 = pA0[6];
            rB0 = *pB0;
            rC0_0 += rA0 * rB0;
            pB0 += incBk;
            rA0 = pA0[7];
            rB0 = *pB0;
            rC0_0 += rA0 * rB0;
            pB0 += incBk;
            rA0 = pA0[8];
            rB0 = *pB0;
            rC0_0 += rA0 * rB0;
            pB0 += incBk;
            break;
         case 10:
            rA0 = *pA0;
            rB0 = *pB0;
            rC0_0 += rA0 * rB0;
            pB0 += incBk;
            rA0 = pA0[1];
            rB0 = *pB0;
            rC0_0 += rA0 * rB0;
            pB0 += incBk;
            rA0 = pA0[2];
            rB0 = *pB0;
            rC0_0 += rA0 * rB0;
            pB0 += incBk;
            rA0 = pA0[3];
            rB0 = *pB0;
            rC0_0 += rA0 * rB0;
            pB0 += incBk;
            rA0 = pA0[4];
            rB0 = *pB0;
            rC0_0 += rA0 * rB0;
            pB0 += incBk;
            rA0 = pA0[5];
            rB0 = *pB0;
            rC0_0 += rA0 * rB0;
            pB0 += incBk;
            rA0 = pA0[6];
            rB0 = *pB0;
            rC0_0 += rA0 * rB0;
            pB0 += incBk;
            rA0 = pA0[7];
            rB0 = *pB0;
            rC0_0 += rA0 * rB0;
            pB0 += incBk;
            rA0 = pA0[8];
            rB0 = *pB0;
            rC0_0 += rA0 * rB0;
            pB0 += incBk;
            rA0 = pA0[9];
            rB0 = *pB0;
            rC0_0 += rA0 * rB0;
            pB0 += incBk;
            break;
         case 11:
            rA0 = *pA0;
            rB0 = *pB0;
            rC0_0 += rA0 * rB0;
            pB0 += incBk;
            rA0 = pA0[1];
            rB0 = *pB0;
            rC0_0 += rA0 * rB0;
            pB0 += incBk;
            rA0 = pA0[2];
            rB0 = *pB0;
            rC0_0 += rA0 * rB0;
            pB0 += incBk;
            rA0 = pA0[3];
            rB0 = *pB0;
            rC0_0 += rA0 * rB0;
            pB0 += incBk;
            rA0 = pA0[4];
            rB0 = *pB0;
            rC0_0 += rA0 * rB0;
            pB0 += incBk;
            rA0 = pA0[5];
            rB0 = *pB0;
            rC0_0 += rA0 * rB0;
            pB0 += incBk;
            rA0 = pA0[6];
            rB0 = *pB0;
            rC0_0 += rA0 * rB0;
            pB0 += incBk;
            rA0 = pA0[7];
            rB0 = *pB0;
            rC0_0 += rA0 * rB0;
            pB0 += incBk;
            rA0 = pA0[8];
            rB0 = *pB0;
            rC0_0 += rA0 * rB0;
            pB0 += incBk;
            rA0 = pA0[9];
            rB0 = *pB0;
            rC0_0 += rA0 * rB0;
            pB0 += incBk;
            rA0 = pA0[10];
            rB0 = *pB0;
            rC0_0 += rA0 * rB0;
            pB0 += incBk;
            break;
         case 0: ;
         }
         pB0 -= k*incBk;
         rB0 = alpha;
         rC0_0 *= rB0;
         *pC0 = rC0_0;
         pC0 += incCm;
         pA0 += incAm;
         pB0 += incBm;
      }
      while(pA0 != stM);
      pC0 += incCn;
      pA0 += incAn;
      pB0 += incBn;
   }
   while(pB0 != stN);
}
#ifdef incAm
   #undef incAm
#endif
#ifdef incAn
   #undef incAn
#endif
#ifdef incAk
   #undef incAk
#endif
#ifdef incBm
   #undef incBm
#endif
#ifdef incBn
   #undef incBn
#endif
#ifdef incBk
   #undef incBk
#endif
#ifdef incCm
   #undef incCm
#endif
#ifdef incCn
   #undef incCn
#endif
#ifdef incCk
   #undef incCk
#endif
#ifdef Mb
   #undef Mb
#endif
#ifdef Nb
   #undef Nb
#endif
#ifdef Kb
   #undef Kb
#endif
void ATL_sJIK0x0x0TT0x0x0_aX_bX
   (const int M, const int N, const int K, const float alpha, const float * ATL_RESTRICT A, const int lda, const float * ATL_RESTRICT B, const int ldb, const float beta, float * ATL_RESTRICT C, const int ldc)
/*
 * matmul with TA=T, TB=T, MB=0, NB=0, KB=0, 
 * lda=0, ldb=0, ldc=0, mu=12, nu=1, ku=12, pf=1
 * Generated by ATLAS/tune/blas/gemm/emit_mm.c (3.10.3)
 */
{
   const int Mb = (M/12)*12;
   #define Nb N
   const int Kb = (K/12)*12;
   const float *ca=A, *cb=B;
   float *cc=C;
   const float *stM = A + (lda*Mb);
   const float *stN = B + (Nb);
   const float *pfA = A + M;
   const float BetaAlpha = beta / alpha;
   #define incAk 12
   const int incAm = ((((lda) << 3)+((lda) << 2)) - Kb), incAn = -(Mb*lda);
   const int incBk = (ldb), incBm = -(Kb*ldb);
   #define incBn 1
   #define incCm 12
   const int incCn = (ldc) - (Mb);
   float *pC0=C;
   const float *pA0=A, *pA1=pA0+(lda), *pA2=pA1+(lda), *pA3=pA2+(lda), *pA4=pA3+(lda), *pA5=pA4+(lda), *pA6=pA5+(lda), *pA7=pA6+(lda), *pA8=pA7+(lda), *pA9=pA8+(lda), *pA10=pA9+(lda), *pA11=pA10+(lda);
   const float *pB0=B;
   register int k;
   register float rA0, rA1, rA2, rA3, rA4, rA5, rA6, rA7, rA8, rA9, rA10, rA11;
   register float rB0;
   register float rC0_0, rC1_0, rC2_0, rC3_0, rC4_0, rC5_0, rC6_0, rC7_0, rC8_0, rC9_0, rC10_0, rC11_0;
   if (pA0 != stM)
   {
      do /* N-loop */
      {
         ATL_pfl1R(pfA+0);
         ATL_pfl1R(pfA+16);
         pfA += lda;
         do /* M-loop */
         {
            rA0 = BetaAlpha;
            rC0_0 = *pC0;
            rC0_0 *= rA0;
            rC1_0 = pC0[1];
            rC1_0 *= rA0;
            rC2_0 = pC0[2];
            rC2_0 *= rA0;
            rC3_0 = pC0[3];
            rC3_0 *= rA0;
            rC4_0 = pC0[4];
            rC4_0 *= rA0;
            rC5_0 = pC0[5];
            rC5_0 *= rA0;
            rC6_0 = pC0[6];
            rC6_0 *= rA0;
            rC7_0 = pC0[7];
            rC7_0 *= rA0;
            rC8_0 = pC0[8];
            rC8_0 *= rA0;
            rC9_0 = pC0[9];
            rC9_0 *= rA0;
            rC10_0 = pC0[10];
            rC10_0 *= rA0;
            rC11_0 = pC0[11];
            rC11_0 *= rA0;
            for (k=0; k < Kb; k += 12) /* easy loop to unroll */
            {
               rA0 = *pA0;
               rB0 = *pB0;
               rA1 = *pA1;
               rA2 = *pA2;
               rA3 = *pA3;
               rC0_0 += rA0 * rB0;
               rA4 = *pA4;
               rA5 = *pA5;
               rC1_0 += rA1 * rB0;
               rA6 = *pA6;
               rA7 = *pA7;
               rC2_0 += rA2 * rB0;
               rA8 = *pA8;
               rA9 = *pA9;
               rC3_0 += rA3 * rB0;
               rA10 = *pA10;
               rA11 = *pA11;
               rC4_0 += rA4 * rB0;
               rC5_0 += rA5 * rB0;
               rC6_0 += rA6 * rB0;
               rC7_0 += rA7 * rB0;
               rC8_0 += rA8 * rB0;
               rC9_0 += rA9 * rB0;
               rC10_0 += rA10 * rB0;
               rC11_0 += rA11 * rB0;
               pB0 += incBk;
               rA0 = pA0[1];
               rB0 = *pB0;
               rA1 = pA1[1];
               rA2 = pA2[1];
               rA3 = pA3[1];
               rC0_0 += rA0 * rB0;
               rA4 = pA4[1];
               rA5 = pA5[1];
               rC1_0 += rA1 * rB0;
               rA6 = pA6[1];
               rA7 = pA7[1];
               rC2_0 += rA2 * rB0;
               rA8 = pA8[1];
               rA9 = pA9[1];
               rC3_0 += rA3 * rB0;
               rA10 = pA10[1];
               rA11 = pA11[1];
               rC4_0 += rA4 * rB0;
               rC5_0 += rA5 * rB0;
               rC6_0 += rA6 * rB0;
               rC7_0 += rA7 * rB0;
               rC8_0 += rA8 * rB0;
               rC9_0 += rA9 * rB0;
               rC10_0 += rA10 * rB0;
               rC11_0 += rA11 * rB0;
               pB0 += incBk;
               rA0 = pA0[2];
               rB0 = *pB0;
               rA1 = pA1[2];
               rA2 = pA2[2];
               rA3 = pA3[2];
               rC0_0 += rA0 * rB0;
               rA4 = pA4[2];
               rA5 = pA5[2];
               rC1_0 += rA1 * rB0;
               rA6 = pA6[2];
               rA7 = pA7[2];
               rC2_0 += rA2 * rB0;
               rA8 = pA8[2];
               rA9 = pA9[2];
               rC3_0 += rA3 * rB0;
               rA10 = pA10[2];
               rA11 = pA11[2];
               rC4_0 += rA4 * rB0;
               rC5_0 += rA5 * rB0;
               rC6_0 += rA6 * rB0;
               rC7_0 += rA7 * rB0;
               rC8_0 += rA8 * rB0;
               rC9_0 += rA9 * rB0;
               rC10_0 += rA10 * rB0;
               rC11_0 += rA11 * rB0;
               pB0 += incBk;
               rA0 = pA0[3];
               rB0 = *pB0;
               rA1 = pA1[3];
               rA2 = pA2[3];
               rA3 = pA3[3];
               rC0_0 += rA0 * rB0;
               rA4 = pA4[3];
               rA5 = pA5[3];
               rC1_0 += rA1 * rB0;
               rA6 = pA6[3];
               rA7 = pA7[3];
               rC2_0 += rA2 * rB0;
               rA8 = pA8[3];
               rA9 = pA9[3];
               rC3_0 += rA3 * rB0;
               rA10 = pA10[3];
               rA11 = pA11[3];
               rC4_0 += rA4 * rB0;
               rC5_0 += rA5 * rB0;
               rC6_0 += rA6 * rB0;
               rC7_0 += rA7 * rB0;
               rC8_0 += rA8 * rB0;
               rC9_0 += rA9 * rB0;
               rC10_0 += rA10 * rB0;
               rC11_0 += rA11 * rB0;
               pB0 += incBk;
               rA0 = pA0[4];
               rB0 = *pB0;
               rA1 = pA1[4];
               rA2 = pA2[4];
               rA3 = pA3[4];
               rC0_0 += rA0 * rB0;
               rA4 = pA4[4];
               rA5 = pA5[4];
               rC1_0 += rA1 * rB0;
               rA6 = pA6[4];
               rA7 = pA7[4];
               rC2_0 += rA2 * rB0;
               rA8 = pA8[4];
               rA9 = pA9[4];
               rC3_0 += rA3 * rB0;
               rA10 = pA10[4];
               rA11 = pA11[4];
               rC4_0 += rA4 * rB0;
               rC5_0 += rA5 * rB0;
               rC6_0 += rA6 * rB0;
               rC7_0 += rA7 * rB0;
               rC8_0 += rA8 * rB0;
               rC9_0 += rA9 * rB0;
               rC10_0 += rA10 * rB0;
               rC11_0 += rA11 * rB0;
               pB0 += incBk;
               rA0 = pA0[5];
               rB0 = *pB0;
               rA1 = pA1[5];
               rA2 = pA2[5];
               rA3 = pA3[5];
               rC0_0 += rA0 * rB0;
               rA4 = pA4[5];
               rA5 = pA5[5];
               rC1_0 += rA1 * rB0;
               rA6 = pA6[5];
               rA7 = pA7[5];
               rC2_0 += rA2 * rB0;
               rA8 = pA8[5];
               rA9 = pA9[5];
               rC3_0 += rA3 * rB0;
               rA10 = pA10[5];
               rA11 = pA11[5];
               rC4_0 += rA4 * rB0;
               rC5_0 += rA5 * rB0;
               rC6_0 += rA6 * rB0;
               rC7_0 += rA7 * rB0;
               rC8_0 += rA8 * rB0;
               rC9_0 += rA9 * rB0;
               rC10_0 += rA10 * rB0;
               rC11_0 += rA11 * rB0;
               pB0 += incBk;
               rA0 = pA0[6];
               rB0 = *pB0;
               rA1 = pA1[6];
               rA2 = pA2[6];
               rA3 = pA3[6];
               rC0_0 += rA0 * rB0;
               rA4 = pA4[6];
               rA5 = pA5[6];
               rC1_0 += rA1 * rB0;
               rA6 = pA6[6];
               rA7 = pA7[6];
               rC2_0 += rA2 * rB0;
               rA8 = pA8[6];
               rA9 = pA9[6];
               rC3_0 += rA3 * rB0;
               rA10 = pA10[6];
               rA11 = pA11[6];
               rC4_0 += rA4 * rB0;
               rC5_0 += rA5 * rB0;
               rC6_0 += rA6 * rB0;
               rC7_0 += rA7 * rB0;
               rC8_0 += rA8 * rB0;
               rC9_0 += rA9 * rB0;
               rC10_0 += rA10 * rB0;
               rC11_0 += rA11 * rB0;
               pB0 += incBk;
               rA0 = pA0[7];
               rB0 = *pB0;
               rA1 = pA1[7];
               rA2 = pA2[7];
               rA3 = pA3[7];
               rC0_0 += rA0 * rB0;
               rA4 = pA4[7];
               rA5 = pA5[7];
               rC1_0 += rA1 * rB0;
               rA6 = pA6[7];
               rA7 = pA7[7];
               rC2_0 += rA2 * rB0;
               rA8 = pA8[7];
               rA9 = pA9[7];
               rC3_0 += rA3 * rB0;
               rA10 = pA10[7];
               rA11 = pA11[7];
               rC4_0 += rA4 * rB0;
               rC5_0 += rA5 * rB0;
               rC6_0 += rA6 * rB0;
               rC7_0 += rA7 * rB0;
               rC8_0 += rA8 * rB0;
               rC9_0 += rA9 * rB0;
               rC10_0 += rA10 * rB0;
               rC11_0 += rA11 * rB0;
               pB0 += incBk;
               rA0 = pA0[8];
               rB0 = *pB0;
               rA1 = pA1[8];
               rA2 = pA2[8];
               rA3 = pA3[8];
               rC0_0 += rA0 * rB0;
               rA4 = pA4[8];
               rA5 = pA5[8];
               rC1_0 += rA1 * rB0;
               rA6 = pA6[8];
               rA7 = pA7[8];
               rC2_0 += rA2 * rB0;
               rA8 = pA8[8];
               rA9 = pA9[8];
               rC3_0 += rA3 * rB0;
               rA10 = pA10[8];
               rA11 = pA11[8];
               rC4_0 += rA4 * rB0;
               rC5_0 += rA5 * rB0;
               rC6_0 += rA6 * rB0;
               rC7_0 += rA7 * rB0;
               rC8_0 += rA8 * rB0;
               rC9_0 += rA9 * rB0;
               rC10_0 += rA10 * rB0;
               rC11_0 += rA11 * rB0;
               pB0 += incBk;
               rA0 = pA0[9];
               rB0 = *pB0;
               rA1 = pA1[9];
               rA2 = pA2[9];
               rA3 = pA3[9];
               rC0_0 += rA0 * rB0;
               rA4 = pA4[9];
               rA5 = pA5[9];
               rC1_0 += rA1 * rB0;
               rA6 = pA6[9];
               rA7 = pA7[9];
               rC2_0 += rA2 * rB0;
               rA8 = pA8[9];
               rA9 = pA9[9];
               rC3_0 += rA3 * rB0;
               rA10 = pA10[9];
               rA11 = pA11[9];
               rC4_0 += rA4 * rB0;
               rC5_0 += rA5 * rB0;
               rC6_0 += rA6 * rB0;
               rC7_0 += rA7 * rB0;
               rC8_0 += rA8 * rB0;
               rC9_0 += rA9 * rB0;
               rC10_0 += rA10 * rB0;
               rC11_0 += rA11 * rB0;
               pB0 += incBk;
               rA0 = pA0[10];
               rB0 = *pB0;
               rA1 = pA1[10];
               rA2 = pA2[10];
               rA3 = pA3[10];
               rC0_0 += rA0 * rB0;
               rA4 = pA4[10];
               rA5 = pA5[10];
               rC1_0 += rA1 * rB0;
               rA6 = pA6[10];
               rA7 = pA7[10];
               rC2_0 += rA2 * rB0;
               rA8 = pA8[10];
               rA9 = pA9[10];
               rC3_0 += rA3 * rB0;
               rA10 = pA10[10];
               rA11 = pA11[10];
               rC4_0 += rA4 * rB0;
               rC5_0 += rA5 * rB0;
               rC6_0 += rA6 * rB0;
               rC7_0 += rA7 * rB0;
               rC8_0 += rA8 * rB0;
               rC9_0 += rA9 * rB0;
               rC10_0 += rA10 * rB0;
               rC11_0 += rA11 * rB0;
               pB0 += incBk;
               rA0 = pA0[11];
               rB0 = *pB0;
               rA1 = pA1[11];
               rA2 = pA2[11];
               rA3 = pA3[11];
               rC0_0 += rA0 * rB0;
               rA4 = pA4[11];
               rA5 = pA5[11];
               rC1_0 += rA1 * rB0;
               rA6 = pA6[11];
               rA7 = pA7[11];
               rC2_0 += rA2 * rB0;
               rA8 = pA8[11];
               rA9 = pA9[11];
               rC3_0 += rA3 * rB0;
               rA10 = pA10[11];
               rA11 = pA11[11];
               rC4_0 += rA4 * rB0;
               rC5_0 += rA5 * rB0;
               rC6_0 += rA6 * rB0;
               rC7_0 += rA7 * rB0;
               rC8_0 += rA8 * rB0;
               rC9_0 += rA9 * rB0;
               rC10_0 += rA10 * rB0;
               rC11_0 += rA11 * rB0;
               pB0 += incBk;
               pA0 += incAk;
               pA1 += incAk;
               pA2 += incAk;
               pA3 += incAk;
               pA4 += incAk;
               pA5 += incAk;
               pA6 += incAk;
               pA7 += incAk;
               pA8 += incAk;
               pA9 += incAk;
               pA10 += incAk;
               pA11 += incAk;
            }
            switch(k = (K-Kb))
            {
            case 1:
               rA0 = *pA0;
               rB0 = *pB0;
               rA1 = *pA1;
               rA2 = *pA2;
               rA3 = *pA3;
               rC0_0 += rA0 * rB0;
               rA4 = *pA4;
               rA5 = *pA5;
               rC1_0 += rA1 * rB0;
               rA6 = *pA6;
               rA7 = *pA7;
               rC2_0 += rA2 * rB0;
               rA8 = *pA8;
               rA9 = *pA9;
               rC3_0 += rA3 * rB0;
               rA10 = *pA10;
               rA11 = *pA11;
               rC4_0 += rA4 * rB0;
               rC5_0 += rA5 * rB0;
               rC6_0 += rA6 * rB0;
               rC7_0 += rA7 * rB0;
               rC8_0 += rA8 * rB0;
               rC9_0 += rA9 * rB0;
               rC10_0 += rA10 * rB0;
               rC11_0 += rA11 * rB0;
               pB0 += incBk;
               break;
            case 2:
               rA0 = *pA0;
               rB0 = *pB0;
               rA1 = *pA1;
               rA2 = *pA2;
               rA3 = *pA3;
               rC0_0 += rA0 * rB0;
               rA4 = *pA4;
               rA5 = *pA5;
               rC1_0 += rA1 * rB0;
               rA6 = *pA6;
               rA7 = *pA7;
               rC2_0 += rA2 * rB0;
               rA8 = *pA8;
               rA9 = *pA9;
               rC3_0 += rA3 * rB0;
               rA10 = *pA10;
               rA11 = *pA11;
               rC4_0 += rA4 * rB0;
               rC5_0 += rA5 * rB0;
               rC6_0 += rA6 * rB0;
               rC7_0 += rA7 * rB0;
               rC8_0 += rA8 * rB0;
               rC9_0 += rA9 * rB0;
               rC10_0 += rA10 * rB0;
               rC11_0 += rA11 * rB0;
               pB0 += incBk;
               rA0 = pA0[1];
               rB0 = *pB0;
               rA1 = pA1[1];
               rA2 = pA2[1];
               rA3 = pA3[1];
               rC0_0 += rA0 * rB0;
               rA4 = pA4[1];
               rA5 = pA5[1];
               rC1_0 += rA1 * rB0;
               rA6 = pA6[1];
               rA7 = pA7[1];
               rC2_0 += rA2 * rB0;
               rA8 = pA8[1];
               rA9 = pA9[1];
               rC3_0 += rA3 * rB0;
               rA10 = pA10[1];
               rA11 = pA11[1];
               rC4_0 += rA4 * rB0;
               rC5_0 += rA5 * rB0;
               rC6_0 += rA6 * rB0;
               rC7_0 += rA7 * rB0;
               rC8_0 += rA8 * rB0;
               rC9_0 += rA9 * rB0;
               rC10_0 += rA10 * rB0;
               rC11_0 += rA11 * rB0;
               pB0 += incBk;
               break;
            case 3:
               rA0 = *pA0;
               rB0 = *pB0;
               rA1 = *pA1;
               rA2 = *pA2;
               rA3 = *pA3;
               rC0_0 += rA0 * rB0;
               rA4 = *pA4;
               rA5 = *pA5;
               rC1_0 += rA1 * rB0;
               rA6 = *pA6;
               rA7 = *pA7;
               rC2_0 += rA2 * rB0;
               rA8 = *pA8;
               rA9 = *pA9;
               rC3_0 += rA3 * rB0;
               rA10 = *pA10;
               rA11 = *pA11;
               rC4_0 += rA4 * rB0;
               rC5_0 += rA5 * rB0;
               rC6_0 += rA6 * rB0;
               rC7_0 += rA7 * rB0;
               rC8_0 += rA8 * rB0;
               rC9_0 += rA9 * rB0;
               rC10_0 += rA10 * rB0;
               rC11_0 += rA11 * rB0;
               pB0 += incBk;
               rA0 = pA0[1];
               rB0 = *pB0;
               rA1 = pA1[1];
               rA2 = pA2[1];
               rA3 = pA3[1];
               rC0_0 += rA0 * rB0;
               rA4 = pA4[1];
               rA5 = pA5[1];
               rC1_0 += rA1 * rB0;
               rA6 = pA6[1];
               rA7 = pA7[1];
               rC2_0 += rA2 * rB0;
               rA8 = pA8[1];
               rA9 = pA9[1];
               rC3_0 += rA3 * rB0;
               rA10 = pA10[1];
               rA11 = pA11[1];
               rC4_0 += rA4 * rB0;
               rC5_0 += rA5 * rB0;
               rC6_0 += rA6 * rB0;
               rC7_0 += rA7 * rB0;
               rC8_0 += rA8 * rB0;
               rC9_0 += rA9 * rB0;
               rC10_0 += rA10 * rB0;
               rC11_0 += rA11 * rB0;
               pB0 += incBk;
               rA0 = pA0[2];
               rB0 = *pB0;
               rA1 = pA1[2];
               rA2 = pA2[2];
               rA3 = pA3[2];
               rC0_0 += rA0 * rB0;
               rA4 = pA4[2];
               rA5 = pA5[2];
               rC1_0 += rA1 * rB0;
               rA6 = pA6[2];
               rA7 = pA7[2];
               rC2_0 += rA2 * rB0;
               rA8 = pA8[2];
               rA9 = pA9[2];
               rC3_0 += rA3 * rB0;
               rA10 = pA10[2];
               rA11 = pA11[2];
               rC4_0 += rA4 * rB0;
               rC5_0 += rA5 * rB0;
               rC6_0 += rA6 * rB0;
               rC7_0 += rA7 * rB0;
               rC8_0 += rA8 * rB0;
               rC9_0 += rA9 * rB0;
               rC10_0 += rA10 * rB0;
               rC11_0 += rA11 * rB0;
               pB0 += incBk;
               break;
            case 4:
               rA0 = *pA0;
               rB0 = *pB0;
               rA1 = *pA1;
               rA2 = *pA2;
               rA3 = *pA3;
               rC0_0 += rA0 * rB0;
               rA4 = *pA4;
               rA5 = *pA5;
               rC1_0 += rA1 * rB0;
               rA6 = *pA6;
               rA7 = *pA7;
               rC2_0 += rA2 * rB0;
               rA8 = *pA8;
               rA9 = *pA9;
               rC3_0 += rA3 * rB0;
               rA10 = *pA10;
               rA11 = *pA11;
               rC4_0 += rA4 * rB0;
               rC5_0 += rA5 * rB0;
               rC6_0 += rA6 * rB0;
               rC7_0 += rA7 * rB0;
               rC8_0 += rA8 * rB0;
               rC9_0 += rA9 * rB0;
               rC10_0 += rA10 * rB0;
               rC11_0 += rA11 * rB0;
               pB0 += incBk;
               rA0 = pA0[1];
               rB0 = *pB0;
               rA1 = pA1[1];
               rA2 = pA2[1];
               rA3 = pA3[1];
               rC0_0 += rA0 * rB0;
               rA4 = pA4[1];
               rA5 = pA5[1];
               rC1_0 += rA1 * rB0;
               rA6 = pA6[1];
               rA7 = pA7[1];
               rC2_0 += rA2 * rB0;
               rA8 = pA8[1];
               rA9 = pA9[1];
               rC3_0 += rA3 * rB0;
               rA10 = pA10[1];
               rA11 = pA11[1];
               rC4_0 += rA4 * rB0;
               rC5_0 += rA5 * rB0;
               rC6_0 += rA6 * rB0;
               rC7_0 += rA7 * rB0;
               rC8_0 += rA8 * rB0;
               rC9_0 += rA9 * rB0;
               rC10_0 += rA10 * rB0;
               rC11_0 += rA11 * rB0;
               pB0 += incBk;
               rA0 = pA0[2];
               rB0 = *pB0;
               rA1 = pA1[2];
               rA2 = pA2[2];
               rA3 = pA3[2];
               rC0_0 += rA0 * rB0;
               rA4 = pA4[2];
               rA5 = pA5[2];
               rC1_0 += rA1 * rB0;
               rA6 = pA6[2];
               rA7 = pA7[2];
               rC2_0 += rA2 * rB0;
               rA8 = pA8[2];
               rA9 = pA9[2];
               rC3_0 += rA3 * rB0;
               rA10 = pA10[2];
               rA11 = pA11[2];
               rC4_0 += rA4 * rB0;
               rC5_0 += rA5 * rB0;
               rC6_0 += rA6 * rB0;
               rC7_0 += rA7 * rB0;
               rC8_0 += rA8 * rB0;
               rC9_0 += rA9 * rB0;
               rC10_0 += rA10 * rB0;
               rC11_0 += rA11 * rB0;
               pB0 += incBk;
               rA0 = pA0[3];
               rB0 = *pB0;
               rA1 = pA1[3];
               rA2 = pA2[3];
               rA3 = pA3[3];
               rC0_0 += rA0 * rB0;
               rA4 = pA4[3];
               rA5 = pA5[3];
               rC1_0 += rA1 * rB0;
               rA6 = pA6[3];
               rA7 = pA7[3];
               rC2_0 += rA2 * rB0;
               rA8 = pA8[3];
               rA9 = pA9[3];
               rC3_0 += rA3 * rB0;
               rA10 = pA10[3];
               rA11 = pA11[3];
               rC4_0 += rA4 * rB0;
               rC5_0 += rA5 * rB0;
               rC6_0 += rA6 * rB0;
               rC7_0 += rA7 * rB0;
               rC8_0 += rA8 * rB0;
               rC9_0 += rA9 * rB0;
               rC10_0 += rA10 * rB0;
               rC11_0 += rA11 * rB0;
               pB0 += incBk;
               break;
            case 5:
               rA0 = *pA0;
               rB0 = *pB0;
               rA1 = *pA1;
               rA2 = *pA2;
               rA3 = *pA3;
               rC0_0 += rA0 * rB0;
               rA4 = *pA4;
               rA5 = *pA5;
               rC1_0 += rA1 * rB0;
               rA6 = *pA6;
               rA7 = *pA7;
               rC2_0 += rA2 * rB0;
               rA8 = *pA8;
               rA9 = *pA9;
               rC3_0 += rA3 * rB0;
               rA10 = *pA10;
               rA11 = *pA11;
               rC4_0 += rA4 * rB0;
               rC5_0 += rA5 * rB0;
               rC6_0 += rA6 * rB0;
               rC7_0 += rA7 * rB0;
               rC8_0 += rA8 * rB0;
               rC9_0 += rA9 * rB0;
               rC10_0 += rA10 * rB0;
               rC11_0 += rA11 * rB0;
               pB0 += incBk;
               rA0 = pA0[1];
               rB0 = *pB0;
               rA1 = pA1[1];
               rA2 = pA2[1];
               rA3 = pA3[1];
               rC0_0 += rA0 * rB0;
               rA4 = pA4[1];
               rA5 = pA5[1];
               rC1_0 += rA1 * rB0;
               rA6 = pA6[1];
               rA7 = pA7[1];
               rC2_0 += rA2 * rB0;
               rA8 = pA8[1];
               rA9 = pA9[1];
               rC3_0 += rA3 * rB0;
               rA10 = pA10[1];
               rA11 = pA11[1];
               rC4_0 += rA4 * rB0;
               rC5_0 += rA5 * rB0;
               rC6_0 += rA6 * rB0;
               rC7_0 += rA7 * rB0;
               rC8_0 += rA8 * rB0;
               rC9_0 += rA9 * rB0;
               rC10_0 += rA10 * rB0;
               rC11_0 += rA11 * rB0;
               pB0 += incBk;
               rA0 = pA0[2];
               rB0 = *pB0;
               rA1 = pA1[2];
               rA2 = pA2[2];
               rA3 = pA3[2];
               rC0_0 += rA0 * rB0;
               rA4 = pA4[2];
               rA5 = pA5[2];
               rC1_0 += rA1 * rB0;
               rA6 = pA6[2];
               rA7 = pA7[2];
               rC2_0 += rA2 * rB0;
               rA8 = pA8[2];
               rA9 = pA9[2];
               rC3_0 += rA3 * rB0;
               rA10 = pA10[2];
               rA11 = pA11[2];
               rC4_0 += rA4 * rB0;
               rC5_0 += rA5 * rB0;
               rC6_0 += rA6 * rB0;
               rC7_0 += rA7 * rB0;
               rC8_0 += rA8 * rB0;
               rC9_0 += rA9 * rB0;
               rC10_0 += rA10 * rB0;
               rC11_0 += rA11 * rB0;
               pB0 += incBk;
               rA0 = pA0[3];
               rB0 = *pB0;
               rA1 = pA1[3];
               rA2 = pA2[3];
               rA3 = pA3[3];
               rC0_0 += rA0 * rB0;
               rA4 = pA4[3];
               rA5 = pA5[3];
               rC1_0 += rA1 * rB0;
               rA6 = pA6[3];
               rA7 = pA7[3];
               rC2_0 += rA2 * rB0;
               rA8 = pA8[3];
               rA9 = pA9[3];
               rC3_0 += rA3 * rB0;
               rA10 = pA10[3];
               rA11 = pA11[3];
               rC4_0 += rA4 * rB0;
               rC5_0 += rA5 * rB0;
               rC6_0 += rA6 * rB0;
               rC7_0 += rA7 * rB0;
               rC8_0 += rA8 * rB0;
               rC9_0 += rA9 * rB0;
               rC10_0 += rA10 * rB0;
               rC11_0 += rA11 * rB0;
               pB0 += incBk;
               rA0 = pA0[4];
               rB0 = *pB0;
               rA1 = pA1[4];
               rA2 = pA2[4];
               rA3 = pA3[4];
               rC0_0 += rA0 * rB0;
               rA4 = pA4[4];
               rA5 = pA5[4];
               rC1_0 += rA1 * rB0;
               rA6 = pA6[4];
               rA7 = pA7[4];
               rC2_0 += rA2 * rB0;
               rA8 = pA8[4];
               rA9 = pA9[4];
               rC3_0 += rA3 * rB0;
               rA10 = pA10[4];
               rA11 = pA11[4];
               rC4_0 += rA4 * rB0;
               rC5_0 += rA5 * rB0;
               rC6_0 += rA6 * rB0;
               rC7_0 += rA7 * rB0;
               rC8_0 += rA8 * rB0;
               rC9_0 += rA9 * rB0;
               rC10_0 += rA10 * rB0;
               rC11_0 += rA11 * rB0;
               pB0 += incBk;
               break;
            case 6:
               rA0 = *pA0;
               rB0 = *pB0;
               rA1 = *pA1;
               rA2 = *pA2;
               rA3 = *pA3;
               rC0_0 += rA0 * rB0;
               rA4 = *pA4;
               rA5 = *pA5;
               rC1_0 += rA1 * rB0;
               rA6 = *pA6;
               rA7 = *pA7;
               rC2_0 += rA2 * rB0;
               rA8 = *pA8;
               rA9 = *pA9;
               rC3_0 += rA3 * rB0;
               rA10 = *pA10;
               rA11 = *pA11;
               rC4_0 += rA4 * rB0;
               rC5_0 += rA5 * rB0;
               rC6_0 += rA6 * rB0;
               rC7_0 += rA7 * rB0;
               rC8_0 += rA8 * rB0;
               rC9_0 += rA9 * rB0;
               rC10_0 += rA10 * rB0;
               rC11_0 += rA11 * rB0;
               pB0 += incBk;
               rA0 = pA0[1];
               rB0 = *pB0;
               rA1 = pA1[1];
               rA2 = pA2[1];
               rA3 = pA3[1];
               rC0_0 += rA0 * rB0;
               rA4 = pA4[1];
               rA5 = pA5[1];
               rC1_0 += rA1 * rB0;
               rA6 = pA6[1];
               rA7 = pA7[1];
               rC2_0 += rA2 * rB0;
               rA8 = pA8[1];
               rA9 = pA9[1];
               rC3_0 += rA3 * rB0;
               rA10 = pA10[1];
               rA11 = pA11[1];
               rC4_0 += rA4 * rB0;
               rC5_0 += rA5 * rB0;
               rC6_0 += rA6 * rB0;
               rC7_0 += rA7 * rB0;
               rC8_0 += rA8 * rB0;
               rC9_0 += rA9 * rB0;
               rC10_0 += rA10 * rB0;
               rC11_0 += rA11 * rB0;
               pB0 += incBk;
               rA0 = pA0[2];
               rB0 = *pB0;
               rA1 = pA1[2];
               rA2 = pA2[2];
               rA3 = pA3[2];
               rC0_0 += rA0 * rB0;
               rA4 = pA4[2];
               rA5 = pA5[2];
               rC1_0 += rA1 * rB0;
               rA6 = pA6[2];
               rA7 = pA7[2];
               rC2_0 += rA2 * rB0;
               rA8 = pA8[2];
               rA9 = pA9[2];
               rC3_0 += rA3 * rB0;
               rA10 = pA10[2];
               rA11 = pA11[2];
               rC4_0 += rA4 * rB0;
               rC5_0 += rA5 * rB0;
               rC6_0 += rA6 * rB0;
               rC7_0 += rA7 * rB0;
               rC8_0 += rA8 * rB0;
               rC9_0 += rA9 * rB0;
               rC10_0 += rA10 * rB0;
               rC11_0 += rA11 * rB0;
               pB0 += incBk;
               rA0 = pA0[3];
               rB0 = *pB0;
               rA1 = pA1[3];
               rA2 = pA2[3];
               rA3 = pA3[3];
               rC0_0 += rA0 * rB0;
               rA4 = pA4[3];
               rA5 = pA5[3];
               rC1_0 += rA1 * rB0;
               rA6 = pA6[3];
               rA7 = pA7[3];
               rC2_0 += rA2 * rB0;
               rA8 = pA8[3];
               rA9 = pA9[3];
               rC3_0 += rA3 * rB0;
               rA10 = pA10[3];
               rA11 = pA11[3];
               rC4_0 += rA4 * rB0;
               rC5_0 += rA5 * rB0;
               rC6_0 += rA6 * rB0;
               rC7_0 += rA7 * rB0;
               rC8_0 += rA8 * rB0;
               rC9_0 += rA9 * rB0;
               rC10_0 += rA10 * rB0;
               rC11_0 += rA11 * rB0;
               pB0 += incBk;
               rA0 = pA0[4];
               rB0 = *pB0;
               rA1 = pA1[4];
               rA2 = pA2[4];
               rA3 = pA3[4];
               rC0_0 += rA0 * rB0;
               rA4 = pA4[4];
               rA5 = pA5[4];
               rC1_0 += rA1 * rB0;
               rA6 = pA6[4];
               rA7 = pA7[4];
               rC2_0 += rA2 * rB0;
               rA8 = pA8[4];
               rA9 = pA9[4];
               rC3_0 += rA3 * rB0;
               rA10 = pA10[4];
               rA11 = pA11[4];
               rC4_0 += rA4 * rB0;
               rC5_0 += rA5 * rB0;
               rC6_0 += rA6 * rB0;
               rC7_0 += rA7 * rB0;
               rC8_0 += rA8 * rB0;
               rC9_0 += rA9 * rB0;
               rC10_0 += rA10 * rB0;
               rC11_0 += rA11 * rB0;
               pB0 += incBk;
               rA0 = pA0[5];
               rB0 = *pB0;
               rA1 = pA1[5];
               rA2 = pA2[5];
               rA3 = pA3[5];
               rC0_0 += rA0 * rB0;
               rA4 = pA4[5];
               rA5 = pA5[5];
               rC1_0 += rA1 * rB0;
               rA6 = pA6[5];
               rA7 = pA7[5];
               rC2_0 += rA2 * rB0;
               rA8 = pA8[5];
               rA9 = pA9[5];
               rC3_0 += rA3 * rB0;
               rA10 = pA10[5];
               rA11 = pA11[5];
               rC4_0 += rA4 * rB0;
               rC5_0 += rA5 * rB0;
               rC6_0 += rA6 * rB0;
               rC7_0 += rA7 * rB0;
               rC8_0 += rA8 * rB0;
               rC9_0 += rA9 * rB0;
               rC10_0 += rA10 * rB0;
               rC11_0 += rA11 * rB0;
               pB0 += incBk;
               break;
            case 7:
               rA0 = *pA0;
               rB0 = *pB0;
               rA1 = *pA1;
               rA2 = *pA2;
               rA3 = *pA3;
               rC0_0 += rA0 * rB0;
               rA4 = *pA4;
               rA5 = *pA5;
               rC1_0 += rA1 * rB0;
               rA6 = *pA6;
               rA7 = *pA7;
               rC2_0 += rA2 * rB0;
               rA8 = *pA8;
               rA9 = *pA9;
               rC3_0 += rA3 * rB0;
               rA10 = *pA10;
               rA11 = *pA11;
               rC4_0 += rA4 * rB0;
               rC5_0 += rA5 * rB0;
               rC6_0 += rA6 * rB0;
               rC7_0 += rA7 * rB0;
               rC8_0 += rA8 * rB0;
               rC9_0 += rA9 * rB0;
               rC10_0 += rA10 * rB0;
               rC11_0 += rA11 * rB0;
               pB0 += incBk;
               rA0 = pA0[1];
               rB0 = *pB0;
               rA1 = pA1[1];
               rA2 = pA2[1];
               rA3 = pA3[1];
               rC0_0 += rA0 * rB0;
               rA4 = pA4[1];
               rA5 = pA5[1];
               rC1_0 += rA1 * rB0;
               rA6 = pA6[1];
               rA7 = pA7[1];
               rC2_0 += rA2 * rB0;
               rA8 = pA8[1];
               rA9 = pA9[1];
               rC3_0 += rA3 * rB0;
               rA10 = pA10[1];
               rA11 = pA11[1];
               rC4_0 += rA4 * rB0;
               rC5_0 += rA5 * rB0;
               rC6_0 += rA6 * rB0;
               rC7_0 += rA7 * rB0;
               rC8_0 += rA8 * rB0;
               rC9_0 += rA9 * rB0;
               rC10_0 += rA10 * rB0;
               rC11_0 += rA11 * rB0;
               pB0 += incBk;
               rA0 = pA0[2];
               rB0 = *pB0;
               rA1 = pA1[2];
               rA2 = pA2[2];
               rA3 = pA3[2];
               rC0_0 += rA0 * rB0;
               rA4 = pA4[2];
               rA5 = pA5[2];
               rC1_0 += rA1 * rB0;
               rA6 = pA6[2];
               rA7 = pA7[2];
               rC2_0 += rA2 * rB0;
               rA8 = pA8[2];
               rA9 = pA9[2];
               rC3_0 += rA3 * rB0;
               rA10 = pA10[2];
               rA11 = pA11[2];
               rC4_0 += rA4 * rB0;
               rC5_0 += rA5 * rB0;
               rC6_0 += rA6 * rB0;
               rC7_0 += rA7 * rB0;
               rC8_0 += rA8 * rB0;
               rC9_0 += rA9 * rB0;
               rC10_0 += rA10 * rB0;
               rC11_0 += rA11 * rB0;
               pB0 += incBk;
               rA0 = pA0[3];
               rB0 = *pB0;
               rA1 = pA1[3];
               rA2 = pA2[3];
               rA3 = pA3[3];
               rC0_0 += rA0 * rB0;
               rA4 = pA4[3];
               rA5 = pA5[3];
               rC1_0 += rA1 * rB0;
               rA6 = pA6[3];
               rA7 = pA7[3];
               rC2_0 += rA2 * rB0;
               rA8 = pA8[3];
               rA9 = pA9[3];
               rC3_0 += rA3 * rB0;
               rA10 = pA10[3];
               rA11 = pA11[3];
               rC4_0 += rA4 * rB0;
               rC5_0 += rA5 * rB0;
               rC6_0 += rA6 * rB0;
               rC7_0 += rA7 * rB0;
               rC8_0 += rA8 * rB0;
               rC9_0 += rA9 * rB0;
               rC10_0 += rA10 * rB0;
               rC11_0 += rA11 * rB0;
               pB0 += incBk;
               rA0 = pA0[4];
               rB0 = *pB0;
               rA1 = pA1[4];
               rA2 = pA2[4];
               rA3 = pA3[4];
               rC0_0 += rA0 * rB0;
               rA4 = pA4[4];
               rA5 = pA5[4];
               rC1_0 += rA1 * rB0;
               rA6 = pA6[4];
               rA7 = pA7[4];
               rC2_0 += rA2 * rB0;
               rA8 = pA8[4];
               rA9 = pA9[4];
               rC3_0 += rA3 * rB0;
               rA10 = pA10[4];
               rA11 = pA11[4];
               rC4_0 += rA4 * rB0;
               rC5_0 += rA5 * rB0;
               rC6_0 += rA6 * rB0;
               rC7_0 += rA7 * rB0;
               rC8_0 += rA8 * rB0;
               rC9_0 += rA9 * rB0;
               rC10_0 += rA10 * rB0;
               rC11_0 += rA11 * rB0;
               pB0 += incBk;
               rA0 = pA0[5];
               rB0 = *pB0;
               rA1 = pA1[5];
               rA2 = pA2[5];
               rA3 = pA3[5];
               rC0_0 += rA0 * rB0;
               rA4 = pA4[5];
               rA5 = pA5[5];
               rC1_0 += rA1 * rB0;
               rA6 = pA6[5];
               rA7 = pA7[5];
               rC2_0 += rA2 * rB0;
               rA8 = pA8[5];
               rA9 = pA9[5];
               rC3_0 += rA3 * rB0;
               rA10 = pA10[5];
               rA11 = pA11[5];
               rC4_0 += rA4 * rB0;
               rC5_0 += rA5 * rB0;
               rC6_0 += rA6 * rB0;
               rC7_0 += rA7 * rB0;
               rC8_0 += rA8 * rB0;
               rC9_0 += rA9 * rB0;
               rC10_0 += rA10 * rB0;
               rC11_0 += rA11 * rB0;
               pB0 += incBk;
               rA0 = pA0[6];
               rB0 = *pB0;
               rA1 = pA1[6];
               rA2 = pA2[6];
               rA3 = pA3[6];
               rC0_0 += rA0 * rB0;
               rA4 = pA4[6];
               rA5 = pA5[6];
               rC1_0 += rA1 * rB0;
               rA6 = pA6[6];
               rA7 = pA7[6];
               rC2_0 += rA2 * rB0;
               rA8 = pA8[6];
               rA9 = pA9[6];
               rC3_0 += rA3 * rB0;
               rA10 = pA10[6];
               rA11 = pA11[6];
               rC4_0 += rA4 * rB0;
               rC5_0 += rA5 * rB0;
               rC6_0 += rA6 * rB0;
               rC7_0 += rA7 * rB0;
               rC8_0 += rA8 * rB0;
               rC9_0 += rA9 * rB0;
               rC10_0 += rA10 * rB0;
               rC11_0 += rA11 * rB0;
               pB0 += incBk;
               break;
            case 8:
               rA0 = *pA0;
               rB0 = *pB0;
               rA1 = *pA1;
               rA2 = *pA2;
               rA3 = *pA3;
               rC0_0 += rA0 * rB0;
               rA4 = *pA4;
               rA5 = *pA5;
               rC1_0 += rA1 * rB0;
               rA6 = *pA6;
               rA7 = *pA7;
               rC2_0 += rA2 * rB0;
               rA8 = *pA8;
               rA9 = *pA9;
               rC3_0 += rA3 * rB0;
               rA10 = *pA10;
               rA11 = *pA11;
               rC4_0 += rA4 * rB0;
               rC5_0 += rA5 * rB0;
               rC6_0 += rA6 * rB0;
               rC7_0 += rA7 * rB0;
               rC8_0 += rA8 * rB0;
               rC9_0 += rA9 * rB0;
               rC10_0 += rA10 * rB0;
               rC11_0 += rA11 * rB0;
               pB0 += incBk;
               rA0 = pA0[1];
               rB0 = *pB0;
               rA1 = pA1[1];
               rA2 = pA2[1];
               rA3 = pA3[1];
               rC0_0 += rA0 * rB0;
               rA4 = pA4[1];
               rA5 = pA5[1];
               rC1_0 += rA1 * rB0;
               rA6 = pA6[1];
               rA7 = pA7[1];
               rC2_0 += rA2 * rB0;
               rA8 = pA8[1];
               rA9 = pA9[1];
               rC3_0 += rA3 * rB0;
               rA10 = pA10[1];
               rA11 = pA11[1];
               rC4_0 += rA4 * rB0;
               rC5_0 += rA5 * rB0;
               rC6_0 += rA6 * rB0;
               rC7_0 += rA7 * rB0;
               rC8_0 += rA8 * rB0;
               rC9_0 += rA9 * rB0;
               rC10_0 += rA10 * rB0;
               rC11_0 += rA11 * rB0;
               pB0 += incBk;
               rA0 = pA0[2];
               rB0 = *pB0;
               rA1 = pA1[2];
               rA2 = pA2[2];
               rA3 = pA3[2];
               rC0_0 += rA0 * rB0;
               rA4 = pA4[2];
               rA5 = pA5[2];
               rC1_0 += rA1 * rB0;
               rA6 = pA6[2];
               rA7 = pA7[2];
               rC2_0 += rA2 * rB0;
               rA8 = pA8[2];
               rA9 = pA9[2];
               rC3_0 += rA3 * rB0;
               rA10 = pA10[2];
               rA11 = pA11[2];
               rC4_0 += rA4 * rB0;
               rC5_0 += rA5 * rB0;
               rC6_0 += rA6 * rB0;
               rC7_0 += rA7 * rB0;
               rC8_0 += rA8 * rB0;
               rC9_0 += rA9 * rB0;
               rC10_0 += rA10 * rB0;
               rC11_0 += rA11 * rB0;
               pB0 += incBk;
               rA0 = pA0[3];
               rB0 = *pB0;
               rA1 = pA1[3];
               rA2 = pA2[3];
               rA3 = pA3[3];
               rC0_0 += rA0 * rB0;
               rA4 = pA4[3];
               rA5 = pA5[3];
               rC1_0 += rA1 * rB0;
               rA6 = pA6[3];
               rA7 = pA7[3];
               rC2_0 += rA2 * rB0;
               rA8 = pA8[3];
               rA9 = pA9[3];
               rC3_0 += rA3 * rB0;
               rA10 = pA10[3];
               rA11 = pA11[3];
               rC4_0 += rA4 * rB0;
               rC5_0 += rA5 * rB0;
               rC6_0 += rA6 * rB0;
               rC7_0 += rA7 * rB0;
               rC8_0 += rA8 * rB0;
               rC9_0 += rA9 * rB0;
               rC10_0 += rA10 * rB0;
               rC11_0 += rA11 * rB0;
               pB0 += incBk;
               rA0 = pA0[4];
               rB0 = *pB0;
               rA1 = pA1[4];
               rA2 = pA2[4];
               rA3 = pA3[4];
               rC0_0 += rA0 * rB0;
               rA4 = pA4[4];
               rA5 = pA5[4];
               rC1_0 += rA1 * rB0;
               rA6 = pA6[4];
               rA7 = pA7[4];
               rC2_0 += rA2 * rB0;
               rA8 = pA8[4];
               rA9 = pA9[4];
               rC3_0 += rA3 * rB0;
               rA10 = pA10[4];
               rA11 = pA11[4];
               rC4_0 += rA4 * rB0;
               rC5_0 += rA5 * rB0;
               rC6_0 += rA6 * rB0;
               rC7_0 += rA7 * rB0;
               rC8_0 += rA8 * rB0;
               rC9_0 += rA9 * rB0;
               rC10_0 += rA10 * rB0;
               rC11_0 += rA11 * rB0;
               pB0 += incBk;
               rA0 = pA0[5];
               rB0 = *pB0;
               rA1 = pA1[5];
               rA2 = pA2[5];
               rA3 = pA3[5];
               rC0_0 += rA0 * rB0;
               rA4 = pA4[5];
               rA5 = pA5[5];
               rC1_0 += rA1 * rB0;
               rA6 = pA6[5];
               rA7 = pA7[5];
               rC2_0 += rA2 * rB0;
               rA8 = pA8[5];
               rA9 = pA9[5];
               rC3_0 += rA3 * rB0;
               rA10 = pA10[5];
               rA11 = pA11[5];
               rC4_0 += rA4 * rB0;
               rC5_0 += rA5 * rB0;
               rC6_0 += rA6 * rB0;
               rC7_0 += rA7 * rB0;
               rC8_0 += rA8 * rB0;
               rC9_0 += rA9 * rB0;
               rC10_0 += rA10 * rB0;
               rC11_0 += rA11 * rB0;
               pB0 += incBk;
               rA0 = pA0[6];
               rB0 = *pB0;
               rA1 = pA1[6];
               rA2 = pA2[6];
               rA3 = pA3[6];
               rC0_0 += rA0 * rB0;
               rA4 = pA4[6];
               rA5 = pA5[6];
               rC1_0 += rA1 * rB0;
               rA6 = pA6[6];
               rA7 = pA7[6];
               rC2_0 += rA2 * rB0;
               rA8 = pA8[6];
               rA9 = pA9[6];
               rC3_0 += rA3 * rB0;
               rA10 = pA10[6];
               rA11 = pA11[6];
               rC4_0 += rA4 * rB0;
               rC5_0 += rA5 * rB0;
               rC6_0 += rA6 * rB0;
               rC7_0 += rA7 * rB0;
               rC8_0 += rA8 * rB0;
               rC9_0 += rA9 * rB0;
               rC10_0 += rA10 * rB0;
               rC11_0 += rA11 * rB0;
               pB0 += incBk;
               rA0 = pA0[7];
               rB0 = *pB0;
               rA1 = pA1[7];
               rA2 = pA2[7];
               rA3 = pA3[7];
               rC0_0 += rA0 * rB0;
               rA4 = pA4[7];
               rA5 = pA5[7];
               rC1_0 += rA1 * rB0;
               rA6 = pA6[7];
               rA7 = pA7[7];
               rC2_0 += rA2 * rB0;
               rA8 = pA8[7];
               rA9 = pA9[7];
               rC3_0 += rA3 * rB0;
               rA10 = pA10[7];
               rA11 = pA11[7];
               rC4_0 += rA4 * rB0;
               rC5_0 += rA5 * rB0;
               rC6_0 += rA6 * rB0;
               rC7_0 += rA7 * rB0;
               rC8_0 += rA8 * rB0;
               rC9_0 += rA9 * rB0;
               rC10_0 += rA10 * rB0;
               rC11_0 += rA11 * rB0;
               pB0 += incBk;
               break;
            case 9:
               rA0 = *pA0;
               rB0 = *pB0;
               rA1 = *pA1;
               rA2 = *pA2;
               rA3 = *pA3;
               rC0_0 += rA0 * rB0;
               rA4 = *pA4;
               rA5 = *pA5;
               rC1_0 += rA1 * rB0;
               rA6 = *pA6;
               rA7 = *pA7;
               rC2_0 += rA2 * rB0;
               rA8 = *pA8;
               rA9 = *pA9;
               rC3_0 += rA3 * rB0;
               rA10 = *pA10;
               rA11 = *pA11;
               rC4_0 += rA4 * rB0;
               rC5_0 += rA5 * rB0;
               rC6_0 += rA6 * rB0;
               rC7_0 += rA7 * rB0;
               rC8_0 += rA8 * rB0;
               rC9_0 += rA9 * rB0;
               rC10_0 += rA10 * rB0;
               rC11_0 += rA11 * rB0;
               pB0 += incBk;
               rA0 = pA0[1];
               rB0 = *pB0;
               rA1 = pA1[1];
               rA2 = pA2[1];
               rA3 = pA3[1];
               rC0_0 += rA0 * rB0;
               rA4 = pA4[1];
               rA5 = pA5[1];
               rC1_0 += rA1 * rB0;
               rA6 = pA6[1];
               rA7 = pA7[1];
               rC2_0 += rA2 * rB0;
               rA8 = pA8[1];
               rA9 = pA9[1];
               rC3_0 += rA3 * rB0;
               rA10 = pA10[1];
               rA11 = pA11[1];
               rC4_0 += rA4 * rB0;
               rC5_0 += rA5 * rB0;
               rC6_0 += rA6 * rB0;
               rC7_0 += rA7 * rB0;
               rC8_0 += rA8 * rB0;
               rC9_0 += rA9 * rB0;
               rC10_0 += rA10 * rB0;
               rC11_0 += rA11 * rB0;
               pB0 += incBk;
               rA0 = pA0[2];
               rB0 = *pB0;
               rA1 = pA1[2];
               rA2 = pA2[2];
               rA3 = pA3[2];
               rC0_0 += rA0 * rB0;
               rA4 = pA4[2];
               rA5 = pA5[2];
               rC1_0 += rA1 * rB0;
               rA6 = pA6[2];
               rA7 = pA7[2];
               rC2_0 += rA2 * rB0;
               rA8 = pA8[2];
               rA9 = pA9[2];
               rC3_0 += rA3 * rB0;
               rA10 = pA10[2];
               rA11 = pA11[2];
               rC4_0 += rA4 * rB0;
               rC5_0 += rA5 * rB0;
               rC6_0 += rA6 * rB0;
               rC7_0 += rA7 * rB0;
               rC8_0 += rA8 * rB0;
               rC9_0 += rA9 * rB0;
               rC10_0 += rA10 * rB0;
               rC11_0 += rA11 * rB0;
               pB0 += incBk;
               rA0 = pA0[3];
               rB0 = *pB0;
               rA1 = pA1[3];
               rA2 = pA2[3];
               rA3 = pA3[3];
               rC0_0 += rA0 * rB0;
               rA4 = pA4[3];
               rA5 = pA5[3];
               rC1_0 += rA1 * rB0;
               rA6 = pA6[3];
               rA7 = pA7[3];
               rC2_0 += rA2 * rB0;
               rA8 = pA8[3];
               rA9 = pA9[3];
               rC3_0 += rA3 * rB0;
               rA10 = pA10[3];
               rA11 = pA11[3];
               rC4_0 += rA4 * rB0;
               rC5_0 += rA5 * rB0;
               rC6_0 += rA6 * rB0;
               rC7_0 += rA7 * rB0;
               rC8_0 += rA8 * rB0;
               rC9_0 += rA9 * rB0;
               rC10_0 += rA10 * rB0;
               rC11_0 += rA11 * rB0;
               pB0 += incBk;
               rA0 = pA0[4];
               rB0 = *pB0;
               rA1 = pA1[4];
               rA2 = pA2[4];
               rA3 = pA3[4];
               rC0_0 += rA0 * rB0;
               rA4 = pA4[4];
               rA5 = pA5[4];
               rC1_0 += rA1 * rB0;
               rA6 = pA6[4];
               rA7 = pA7[4];
               rC2_0 += rA2 * rB0;
               rA8 = pA8[4];
               rA9 = pA9[4];
               rC3_0 += rA3 * rB0;
               rA10 = pA10[4];
               rA11 = pA11[4];
               rC4_0 += rA4 * rB0;
               rC5_0 += rA5 * rB0;
               rC6_0 += rA6 * rB0;
               rC7_0 += rA7 * rB0;
               rC8_0 += rA8 * rB0;
               rC9_0 += rA9 * rB0;
               rC10_0 += rA10 * rB0;
               rC11_0 += rA11 * rB0;
               pB0 += incBk;
               rA0 = pA0[5];
               rB0 = *pB0;
               rA1 = pA1[5];
               rA2 = pA2[5];
               rA3 = pA3[5];
               rC0_0 += rA0 * rB0;
               rA4 = pA4[5];
               rA5 = pA5[5];
               rC1_0 += rA1 * rB0;
               rA6 = pA6[5];
               rA7 = pA7[5];
               rC2_0 += rA2 * rB0;
               rA8 = pA8[5];
               rA9 = pA9[5];
               rC3_0 += rA3 * rB0;
               rA10 = pA10[5];
               rA11 = pA11[5];
               rC4_0 += rA4 * rB0;
               rC5_0 += rA5 * rB0;
               rC6_0 += rA6 * rB0;
               rC7_0 += rA7 * rB0;
               rC8_0 += rA8 * rB0;
               rC9_0 += rA9 * rB0;
               rC10_0 += rA10 * rB0;
               rC11_0 += rA11 * rB0;
               pB0 += incBk;
               rA0 = pA0[6];
               rB0 = *pB0;
               rA1 = pA1[6];
               rA2 = pA2[6];
               rA3 = pA3[6];
               rC0_0 += rA0 * rB0;
               rA4 = pA4[6];
               rA5 = pA5[6];
               rC1_0 += rA1 * rB0;
               rA6 = pA6[6];
               rA7 = pA7[6];
               rC2_0 += rA2 * rB0;
               rA8 = pA8[6];
               rA9 = pA9[6];
               rC3_0 += rA3 * rB0;
               rA10 = pA10[6];
               rA11 = pA11[6];
               rC4_0 += rA4 * rB0;
               rC5_0 += rA5 * rB0;
               rC6_0 += rA6 * rB0;
               rC7_0 += rA7 * rB0;
               rC8_0 += rA8 * rB0;
               rC9_0 += rA9 * rB0;
               rC10_0 += rA10 * rB0;
               rC11_0 += rA11 * rB0;
               pB0 += incBk;
               rA0 = pA0[7];
               rB0 = *pB0;
               rA1 = pA1[7];
               rA2 = pA2[7];
               rA3 = pA3[7];
               rC0_0 += rA0 * rB0;
               rA4 = pA4[7];
               rA5 = pA5[7];
               rC1_0 += rA1 * rB0;
               rA6 = pA6[7];
               rA7 = pA7[7];
               rC2_0 += rA2 * rB0;
               rA8 = pA8[7];
               rA9 = pA9[7];
               rC3_0 += rA3 * rB0;
               rA10 = pA10[7];
               rA11 = pA11[7];
               rC4_0 += rA4 * rB0;
               rC5_0 += rA5 * rB0;
               rC6_0 += rA6 * rB0;
               rC7_0 += rA7 * rB0;
               rC8_0 += rA8 * rB0;
               rC9_0 += rA9 * rB0;
               rC10_0 += rA10 * rB0;
               rC11_0 += rA11 * rB0;
               pB0 += incBk;
               rA0 = pA0[8];
               rB0 = *pB0;
               rA1 = pA1[8];
               rA2 = pA2[8];
               rA3 = pA3[8];
               rC0_0 += rA0 * rB0;
               rA4 = pA4[8];
               rA5 = pA5[8];
               rC1_0 += rA1 * rB0;
               rA6 = pA6[8];
               rA7 = pA7[8];
               rC2_0 += rA2 * rB0;
               rA8 = pA8[8];
               rA9 = pA9[8];
               rC3_0 += rA3 * rB0;
               rA10 = pA10[8];
               rA11 = pA11[8];
               rC4_0 += rA4 * rB0;
               rC5_0 += rA5 * rB0;
               rC6_0 += rA6 * rB0;
               rC7_0 += rA7 * rB0;
               rC8_0 += rA8 * rB0;
               rC9_0 += rA9 * rB0;
               rC10_0 += rA10 * rB0;
               rC11_0 += rA11 * rB0;
               pB0 += incBk;
               break;
            case 10:
               rA0 = *pA0;
               rB0 = *pB0;
               rA1 = *pA1;
               rA2 = *pA2;
               rA3 = *pA3;
               rC0_0 += rA0 * rB0;
               rA4 = *pA4;
               rA5 = *pA5;
               rC1_0 += rA1 * rB0;
               rA6 = *pA6;
               rA7 = *pA7;
               rC2_0 += rA2 * rB0;
               rA8 = *pA8;
               rA9 = *pA9;
               rC3_0 += rA3 * rB0;
               rA10 = *pA10;
               rA11 = *pA11;
               rC4_0 += rA4 * rB0;
               rC5_0 += rA5 * rB0;
               rC6_0 += rA6 * rB0;
               rC7_0 += rA7 * rB0;
               rC8_0 += rA8 * rB0;
               rC9_0 += rA9 * rB0;
               rC10_0 += rA10 * rB0;
               rC11_0 += rA11 * rB0;
               pB0 += incBk;
               rA0 = pA0[1];
               rB0 = *pB0;
               rA1 = pA1[1];
               rA2 = pA2[1];
               rA3 = pA3[1];
               rC0_0 += rA0 * rB0;
               rA4 = pA4[1];
               rA5 = pA5[1];
               rC1_0 += rA1 * rB0;
               rA6 = pA6[1];
               rA7 = pA7[1];
               rC2_0 += rA2 * rB0;
               rA8 = pA8[1];
               rA9 = pA9[1];
               rC3_0 += rA3 * rB0;
               rA10 = pA10[1];
               rA11 = pA11[1];
               rC4_0 += rA4 * rB0;
               rC5_0 += rA5 * rB0;
               rC6_0 += rA6 * rB0;
               rC7_0 += rA7 * rB0;
               rC8_0 += rA8 * rB0;
               rC9_0 += rA9 * rB0;
               rC10_0 += rA10 * rB0;
               rC11_0 += rA11 * rB0;
               pB0 += incBk;
               rA0 = pA0[2];
               rB0 = *pB0;
               rA1 = pA1[2];
               rA2 = pA2[2];
               rA3 = pA3[2];
               rC0_0 += rA0 * rB0;
               rA4 = pA4[2];
               rA5 = pA5[2];
               rC1_0 += rA1 * rB0;
               rA6 = pA6[2];
               rA7 = pA7[2];
               rC2_0 += rA2 * rB0;
               rA8 = pA8[2];
               rA9 = pA9[2];
               rC3_0 += rA3 * rB0;
               rA10 = pA10[2];
               rA11 = pA11[2];
               rC4_0 += rA4 * rB0;
               rC5_0 += rA5 * rB0;
               rC6_0 += rA6 * rB0;
               rC7_0 += rA7 * rB0;
               rC8_0 += rA8 * rB0;
               rC9_0 += rA9 * rB0;
               rC10_0 += rA10 * rB0;
               rC11_0 += rA11 * rB0;
               pB0 += incBk;
               rA0 = pA0[3];
               rB0 = *pB0;
               rA1 = pA1[3];
               rA2 = pA2[3];
               rA3 = pA3[3];
               rC0_0 += rA0 * rB0;
               rA4 = pA4[3];
               rA5 = pA5[3];
               rC1_0 += rA1 * rB0;
               rA6 = pA6[3];
               rA7 = pA7[3];
               rC2_0 += rA2 * rB0;
               rA8 = pA8[3];
               rA9 = pA9[3];
               rC3_0 += rA3 * rB0;
               rA10 = pA10[3];
               rA11 = pA11[3];
               rC4_0 += rA4 * rB0;
               rC5_0 += rA5 * rB0;
               rC6_0 += rA6 * rB0;
               rC7_0 += rA7 * rB0;
               rC8_0 += rA8 * rB0;
               rC9_0 += rA9 * rB0;
               rC10_0 += rA10 * rB0;
               rC11_0 += rA11 * rB0;
               pB0 += incBk;
               rA0 = pA0[4];
               rB0 = *pB0;
               rA1 = pA1[4];
               rA2 = pA2[4];
               rA3 = pA3[4];
               rC0_0 += rA0 * rB0;
               rA4 = pA4[4];
               rA5 = pA5[4];
               rC1_0 += rA1 * rB0;
               rA6 = pA6[4];
               rA7 = pA7[4];
               rC2_0 += rA2 * rB0;
               rA8 = pA8[4];
               rA9 = pA9[4];
               rC3_0 += rA3 * rB0;
               rA10 = pA10[4];
               rA11 = pA11[4];
               rC4_0 += rA4 * rB0;
               rC5_0 += rA5 * rB0;
               rC6_0 += rA6 * rB0;
               rC7_0 += rA7 * rB0;
               rC8_0 += rA8 * rB0;
               rC9_0 += rA9 * rB0;
               rC10_0 += rA10 * rB0;
               rC11_0 += rA11 * rB0;
               pB0 += incBk;
               rA0 = pA0[5];
               rB0 = *pB0;
               rA1 = pA1[5];
               rA2 = pA2[5];
               rA3 = pA3[5];
               rC0_0 += rA0 * rB0;
               rA4 = pA4[5];
               rA5 = pA5[5];
               rC1_0 += rA1 * rB0;
               rA6 = pA6[5];
               rA7 = pA7[5];
               rC2_0 += rA2 * rB0;
               rA8 = pA8[5];
               rA9 = pA9[5];
               rC3_0 += rA3 * rB0;
               rA10 = pA10[5];
               rA11 = pA11[5];
               rC4_0 += rA4 * rB0;
               rC5_0 += rA5 * rB0;
               rC6_0 += rA6 * rB0;
               rC7_0 += rA7 * rB0;
               rC8_0 += rA8 * rB0;
               rC9_0 += rA9 * rB0;
               rC10_0 += rA10 * rB0;
               rC11_0 += rA11 * rB0;
               pB0 += incBk;
               rA0 = pA0[6];
               rB0 = *pB0;
               rA1 = pA1[6];
               rA2 = pA2[6];
               rA3 = pA3[6];
               rC0_0 += rA0 * rB0;
               rA4 = pA4[6];
               rA5 = pA5[6];
               rC1_0 += rA1 * rB0;
               rA6 = pA6[6];
               rA7 = pA7[6];
               rC2_0 += rA2 * rB0;
               rA8 = pA8[6];
               rA9 = pA9[6];
               rC3_0 += rA3 * rB0;
               rA10 = pA10[6];
               rA11 = pA11[6];
               rC4_0 += rA4 * rB0;
               rC5_0 += rA5 * rB0;
               rC6_0 += rA6 * rB0;
               rC7_0 += rA7 * rB0;
               rC8_0 += rA8 * rB0;
               rC9_0 += rA9 * rB0;
               rC10_0 += rA10 * rB0;
               rC11_0 += rA11 * rB0;
               pB0 += incBk;
               rA0 = pA0[7];
               rB0 = *pB0;
               rA1 = pA1[7];
               rA2 = pA2[7];
               rA3 = pA3[7];
               rC0_0 += rA0 * rB0;
               rA4 = pA4[7];
               rA5 = pA5[7];
               rC1_0 += rA1 * rB0;
               rA6 = pA6[7];
               rA7 = pA7[7];
               rC2_0 += rA2 * rB0;
               rA8 = pA8[7];
               rA9 = pA9[7];
               rC3_0 += rA3 * rB0;
               rA10 = pA10[7];
               rA11 = pA11[7];
               rC4_0 += rA4 * rB0;
               rC5_0 += rA5 * rB0;
               rC6_0 += rA6 * rB0;
               rC7_0 += rA7 * rB0;
               rC8_0 += rA8 * rB0;
               rC9_0 += rA9 * rB0;
               rC10_0 += rA10 * rB0;
               rC11_0 += rA11 * rB0;
               pB0 += incBk;
               rA0 = pA0[8];
               rB0 = *pB0;
               rA1 = pA1[8];
               rA2 = pA2[8];
               rA3 = pA3[8];
               rC0_0 += rA0 * rB0;
               rA4 = pA4[8];
               rA5 = pA5[8];
               rC1_0 += rA1 * rB0;
               rA6 = pA6[8];
               rA7 = pA7[8];
               rC2_0 += rA2 * rB0;
               rA8 = pA8[8];
               rA9 = pA9[8];
               rC3_0 += rA3 * rB0;
               rA10 = pA10[8];
               rA11 = pA11[8];
               rC4_0 += rA4 * rB0;
               rC5_0 += rA5 * rB0;
               rC6_0 += rA6 * rB0;
               rC7_0 += rA7 * rB0;
               rC8_0 += rA8 * rB0;
               rC9_0 += rA9 * rB0;
               rC10_0 += rA10 * rB0;
               rC11_0 += rA11 * rB0;
               pB0 += incBk;
               rA0 = pA0[9];
               rB0 = *pB0;
               rA1 = pA1[9];
               rA2 = pA2[9];
               rA3 = pA3[9];
               rC0_0 += rA0 * rB0;
               rA4 = pA4[9];
               rA5 = pA5[9];
               rC1_0 += rA1 * rB0;
               rA6 = pA6[9];
               rA7 = pA7[9];
               rC2_0 += rA2 * rB0;
               rA8 = pA8[9];
               rA9 = pA9[9];
               rC3_0 += rA3 * rB0;
               rA10 = pA10[9];
               rA11 = pA11[9];
               rC4_0 += rA4 * rB0;
               rC5_0 += rA5 * rB0;
               rC6_0 += rA6 * rB0;
               rC7_0 += rA7 * rB0;
               rC8_0 += rA8 * rB0;
               rC9_0 += rA9 * rB0;
               rC10_0 += rA10 * rB0;
               rC11_0 += rA11 * rB0;
               pB0 += incBk;
               break;
            case 11:
               rA0 = *pA0;
               rB0 = *pB0;
               rA1 = *pA1;
               rA2 = *pA2;
               rA3 = *pA3;
               rC0_0 += rA0 * rB0;
               rA4 = *pA4;
               rA5 = *pA5;
               rC1_0 += rA1 * rB0;
               rA6 = *pA6;
               rA7 = *pA7;
               rC2_0 += rA2 * rB0;
               rA8 = *pA8;
               rA9 = *pA9;
               rC3_0 += rA3 * rB0;
               rA10 = *pA10;
               rA11 = *pA11;
               rC4_0 += rA4 * rB0;
               rC5_0 += rA5 * rB0;
               rC6_0 += rA6 * rB0;
               rC7_0 += rA7 * rB0;
               rC8_0 += rA8 * rB0;
               rC9_0 += rA9 * rB0;
               rC10_0 += rA10 * rB0;
               rC11_0 += rA11 * rB0;
               pB0 += incBk;
               rA0 = pA0[1];
               rB0 = *pB0;
               rA1 = pA1[1];
               rA2 = pA2[1];
               rA3 = pA3[1];
               rC0_0 += rA0 * rB0;
               rA4 = pA4[1];
               rA5 = pA5[1];
               rC1_0 += rA1 * rB0;
               rA6 = pA6[1];
               rA7 = pA7[1];
               rC2_0 += rA2 * rB0;
               rA8 = pA8[1];
               rA9 = pA9[1];
               rC3_0 += rA3 * rB0;
               rA10 = pA10[1];
               rA11 = pA11[1];
               rC4_0 += rA4 * rB0;
               rC5_0 += rA5 * rB0;
               rC6_0 += rA6 * rB0;
               rC7_0 += rA7 * rB0;
               rC8_0 += rA8 * rB0;
               rC9_0 += rA9 * rB0;
               rC10_0 += rA10 * rB0;
               rC11_0 += rA11 * rB0;
               pB0 += incBk;
               rA0 = pA0[2];
               rB0 = *pB0;
               rA1 = pA1[2];
               rA2 = pA2[2];
               rA3 = pA3[2];
               rC0_0 += rA0 * rB0;
               rA4 = pA4[2];
               rA5 = pA5[2];
               rC1_0 += rA1 * rB0;
               rA6 = pA6[2];
               rA7 = pA7[2];
               rC2_0 += rA2 * rB0;
               rA8 = pA8[2];
               rA9 = pA9[2];
               rC3_0 += rA3 * rB0;
               rA10 = pA10[2];
               rA11 = pA11[2];
               rC4_0 += rA4 * rB0;
               rC5_0 += rA5 * rB0;
               rC6_0 += rA6 * rB0;
               rC7_0 += rA7 * rB0;
               rC8_0 += rA8 * rB0;
               rC9_0 += rA9 * rB0;
               rC10_0 += rA10 * rB0;
               rC11_0 += rA11 * rB0;
               pB0 += incBk;
               rA0 = pA0[3];
               rB0 = *pB0;
               rA1 = pA1[3];
               rA2 = pA2[3];
               rA3 = pA3[3];
               rC0_0 += rA0 * rB0;
               rA4 = pA4[3];
               rA5 = pA5[3];
               rC1_0 += rA1 * rB0;
               rA6 = pA6[3];
               rA7 = pA7[3];
               rC2_0 += rA2 * rB0;
               rA8 = pA8[3];
               rA9 = pA9[3];
               rC3_0 += rA3 * rB0;
               rA10 = pA10[3];
               rA11 = pA11[3];
               rC4_0 += rA4 * rB0;
               rC5_0 += rA5 * rB0;
               rC6_0 += rA6 * rB0;
               rC7_0 += rA7 * rB0;
               rC8_0 += rA8 * rB0;
               rC9_0 += rA9 * rB0;
               rC10_0 += rA10 * rB0;
               rC11_0 += rA11 * rB0;
               pB0 += incBk;
               rA0 = pA0[4];
               rB0 = *pB0;
               rA1 = pA1[4];
               rA2 = pA2[4];
               rA3 = pA3[4];
               rC0_0 += rA0 * rB0;
               rA4 = pA4[4];
               rA5 = pA5[4];
               rC1_0 += rA1 * rB0;
               rA6 = pA6[4];
               rA7 = pA7[4];
               rC2_0 += rA2 * rB0;
               rA8 = pA8[4];
               rA9 = pA9[4];
               rC3_0 += rA3 * rB0;
               rA10 = pA10[4];
               rA11 = pA11[4];
               rC4_0 += rA4 * rB0;
               rC5_0 += rA5 * rB0;
               rC6_0 += rA6 * rB0;
               rC7_0 += rA7 * rB0;
               rC8_0 += rA8 * rB0;
               rC9_0 += rA9 * rB0;
               rC10_0 += rA10 * rB0;
               rC11_0 += rA11 * rB0;
               pB0 += incBk;
               rA0 = pA0[5];
               rB0 = *pB0;
               rA1 = pA1[5];
               rA2 = pA2[5];
               rA3 = pA3[5];
               rC0_0 += rA0 * rB0;
               rA4 = pA4[5];
               rA5 = pA5[5];
               rC1_0 += rA1 * rB0;
               rA6 = pA6[5];
               rA7 = pA7[5];
               rC2_0 += rA2 * rB0;
               rA8 = pA8[5];
               rA9 = pA9[5];
               rC3_0 += rA3 * rB0;
               rA10 = pA10[5];
               rA11 = pA11[5];
               rC4_0 += rA4 * rB0;
               rC5_0 += rA5 * rB0;
               rC6_0 += rA6 * rB0;
               rC7_0 += rA7 * rB0;
               rC8_0 += rA8 * rB0;
               rC9_0 += rA9 * rB0;
               rC10_0 += rA10 * rB0;
               rC11_0 += rA11 * rB0;
               pB0 += incBk;
               rA0 = pA0[6];
               rB0 = *pB0;
               rA1 = pA1[6];
               rA2 = pA2[6];
               rA3 = pA3[6];
               rC0_0 += rA0 * rB0;
               rA4 = pA4[6];
               rA5 = pA5[6];
               rC1_0 += rA1 * rB0;
               rA6 = pA6[6];
               rA7 = pA7[6];
               rC2_0 += rA2 * rB0;
               rA8 = pA8[6];
               rA9 = pA9[6];
               rC3_0 += rA3 * rB0;
               rA10 = pA10[6];
               rA11 = pA11[6];
               rC4_0 += rA4 * rB0;
               rC5_0 += rA5 * rB0;
               rC6_0 += rA6 * rB0;
               rC7_0 += rA7 * rB0;
               rC8_0 += rA8 * rB0;
               rC9_0 += rA9 * rB0;
               rC10_0 += rA10 * rB0;
               rC11_0 += rA11 * rB0;
               pB0 += incBk;
               rA0 = pA0[7];
               rB0 = *pB0;
               rA1 = pA1[7];
               rA2 = pA2[7];
               rA3 = pA3[7];
               rC0_0 += rA0 * rB0;
               rA4 = pA4[7];
               rA5 = pA5[7];
               rC1_0 += rA1 * rB0;
               rA6 = pA6[7];
               rA7 = pA7[7];
               rC2_0 += rA2 * rB0;
               rA8 = pA8[7];
               rA9 = pA9[7];
               rC3_0 += rA3 * rB0;
               rA10 = pA10[7];
               rA11 = pA11[7];
               rC4_0 += rA4 * rB0;
               rC5_0 += rA5 * rB0;
               rC6_0 += rA6 * rB0;
               rC7_0 += rA7 * rB0;
               rC8_0 += rA8 * rB0;
               rC9_0 += rA9 * rB0;
               rC10_0 += rA10 * rB0;
               rC11_0 += rA11 * rB0;
               pB0 += incBk;
               rA0 = pA0[8];
               rB0 = *pB0;
               rA1 = pA1[8];
               rA2 = pA2[8];
               rA3 = pA3[8];
               rC0_0 += rA0 * rB0;
               rA4 = pA4[8];
               rA5 = pA5[8];
               rC1_0 += rA1 * rB0;
               rA6 = pA6[8];
               rA7 = pA7[8];
               rC2_0 += rA2 * rB0;
               rA8 = pA8[8];
               rA9 = pA9[8];
               rC3_0 += rA3 * rB0;
               rA10 = pA10[8];
               rA11 = pA11[8];
               rC4_0 += rA4 * rB0;
               rC5_0 += rA5 * rB0;
               rC6_0 += rA6 * rB0;
               rC7_0 += rA7 * rB0;
               rC8_0 += rA8 * rB0;
               rC9_0 += rA9 * rB0;
               rC10_0 += rA10 * rB0;
               rC11_0 += rA11 * rB0;
               pB0 += incBk;
               rA0 = pA0[9];
               rB0 = *pB0;
               rA1 = pA1[9];
               rA2 = pA2[9];
               rA3 = pA3[9];
               rC0_0 += rA0 * rB0;
               rA4 = pA4[9];
               rA5 = pA5[9];
               rC1_0 += rA1 * rB0;
               rA6 = pA6[9];
               rA7 = pA7[9];
               rC2_0 += rA2 * rB0;
               rA8 = pA8[9];
               rA9 = pA9[9];
               rC3_0 += rA3 * rB0;
               rA10 = pA10[9];
               rA11 = pA11[9];
               rC4_0 += rA4 * rB0;
               rC5_0 += rA5 * rB0;
               rC6_0 += rA6 * rB0;
               rC7_0 += rA7 * rB0;
               rC8_0 += rA8 * rB0;
               rC9_0 += rA9 * rB0;
               rC10_0 += rA10 * rB0;
               rC11_0 += rA11 * rB0;
               pB0 += incBk;
               rA0 = pA0[10];
               rB0 = *pB0;
               rA1 = pA1[10];
               rA2 = pA2[10];
               rA3 = pA3[10];
               rC0_0 += rA0 * rB0;
               rA4 = pA4[10];
               rA5 = pA5[10];
               rC1_0 += rA1 * rB0;
               rA6 = pA6[10];
               rA7 = pA7[10];
               rC2_0 += rA2 * rB0;
               rA8 = pA8[10];
               rA9 = pA9[10];
               rC3_0 += rA3 * rB0;
               rA10 = pA10[10];
               rA11 = pA11[10];
               rC4_0 += rA4 * rB0;
               rC5_0 += rA5 * rB0;
               rC6_0 += rA6 * rB0;
               rC7_0 += rA7 * rB0;
               rC8_0 += rA8 * rB0;
               rC9_0 += rA9 * rB0;
               rC10_0 += rA10 * rB0;
               rC11_0 += rA11 * rB0;
               pB0 += incBk;
               break;
            case 0: ;
            }
            pB0 -= k*incBk;
            rB0 = alpha;
            rC0_0 *= rB0;
            rC1_0 *= rB0;
            rC2_0 *= rB0;
            rC3_0 *= rB0;
            rC4_0 *= rB0;
            rC5_0 *= rB0;
            rC6_0 *= rB0;
            rC7_0 *= rB0;
            rC8_0 *= rB0;
            rC9_0 *= rB0;
            rC10_0 *= rB0;
            rC11_0 *= rB0;
            *pC0 = rC0_0;
            pC0[1] = rC1_0;
            pC0[2] = rC2_0;
            pC0[3] = rC3_0;
            pC0[4] = rC4_0;
            pC0[5] = rC5_0;
            pC0[6] = rC6_0;
            pC0[7] = rC7_0;
            pC0[8] = rC8_0;
            pC0[9] = rC9_0;
            pC0[10] = rC10_0;
            pC0[11] = rC11_0;
            pC0 += incCm;
            pA0 += incAm;
            pA1 += incAm;
            pA2 += incAm;
            pA3 += incAm;
            pA4 += incAm;
            pA5 += incAm;
            pA6 += incAm;
            pA7 += incAm;
            pA8 += incAm;
            pA9 += incAm;
            pA10 += incAm;
            pA11 += incAm;
            pB0 += incBm;
         }
         while(pA0 != stM);
         pC0 += incCn;
         pA0 += incAn;
         pA1 += incAn;
         pA2 += incAn;
         pA3 += incAn;
         pA4 += incAn;
         pA5 += incAn;
         pA6 += incAn;
         pA7 += incAn;
         pA8 += incAn;
         pA9 += incAn;
         pA10 += incAn;
         pA11 += incAn;
         pB0 += incBn;
      }
      while(pB0 != stN);
   }
   if (k=M-Mb)
      ATL_sJIK0x0x0TT1x1x12_aX_bX(k, N, K, alpha, ca + (Mb*lda), lda, cb, ldb, beta, cc + (Mb), ldc);
}
#ifdef incAm
   #undef incAm
#endif
#ifdef incAn
   #undef incAn
#endif
#ifdef incAk
   #undef incAk
#endif
#ifdef incBm
   #undef incBm
#endif
#ifdef incBn
   #undef incBn
#endif
#ifdef incBk
   #undef incBk
#endif
#ifdef incCm
   #undef incCm
#endif
#ifdef incCn
   #undef incCn
#endif
#ifdef incCk
   #undef incCk
#endif
#ifdef Mb
   #undef Mb
#endif
#ifdef Nb
   #undef Nb
#endif
#ifdef Kb
   #undef Kb
#endif
